 {~ Photometric values from pgm files made from raw format images ~}
 {~ as obtained by 'dcraw -D' by Dave Coffin, http://www.shore.net/~dcoffin ~}
 {~ using the 'dcraw -i -v' info or exif info by 'jhead' by Matthias Wandel, 
    http://www.sentex.net/~mwandel/jhead ~}


Program raw2lum;
 {by Jan Hollan, Obs. and Planetarium Brno, version 1.35 2010-03-31 }
 (* Copyright (C) 2005 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)

uses dos, 
     showrem, {unit from http://www.bsdg.org/swag/DOS/0055.PAS.html }
     str_num, un_str_m{, params}, angles_o; {units by J. Hollan}

const
 version='1.35 for Canon 600D not for 5202*3465, just for 2888*2888 pixels'; 
                {0.94 ovlim treated as <=, with respect to pre-0.92, and 
                  YCGM coeff changed from .4 .1 .1 .4 to .4 .1 .4 .1}
		{0.95 dark subtracted from oversaturated pixels as well}
                {0.96 colour band made for all colour-coded ppm's in, 
		  what caused an index for LogCol being too large 
		  for D60 and 300D; corrected in 0.97, where undocumented
		  switches for spectral calibration were present too already}
		{0.98 -BL parameter added, and TI and V switches
		  for spectral calibration documented wihin help}
	        {0.99 GMYC for Nikon 990 in}	 
		{1.00 corrected heading for -ft, smoothing option added,
		 colour scale extended downwards (red for the 1e-4 order),
		 MR and ML multipliers added (alternative to M only)}
		{1.01 the new options work indeed, 
		 1.02 darkframing darkstrip canon D60 files works again}
		{1.03 non-repeating colours (starting orange instead of red,
		 2-nd blue having a halved green added) }
		{1.04  makes a colour 16-bit *.ppm half-size image} 
                {1.05  gives final averages with 1 decimal place,
		  can use an offset frame and scale the (dark-offset) values
		 and keeps an overview of processed images }
		{1.06 deals Nikon990 geometry, 
		       with and without Fish-Eye convertor
                    (setting -fc is needed to make it work, suitable
		    values are 0.214 and 1.03)  
		 and uses a new 1.3 Y - 0.3 G photopic luminance formula for
		 Nikon 990, based on a AM1.5 spectrum image. 
		 Far red is of course 
                 overrepresented by it even more than by 1 Y formula.
		 0.9 Y + 0.1 C was surely not photopic!} 
		{1.07 sets always Y or G as an epsfile count;
		  it puts the smoothing line segments on the correct
		   places without skipping any pixels;
		  -nh option added (no histogram) 
		  -nr option added (no overview) } 
		{1.08 for >= 3 srad, it computes an estimate of SQM reading;
		  true overfull or overMaxL 4-pixels are white instead of black,
		  or are coloured according to the new -o#:#:# option.}
		{1.09 luminance / ang. radius table output added}
                {but with an error, 1.10 correts it}
		{1.11 -j option compares raw with ppm (made from jpeg or tiff)}
	        {1.12 optional azimuth range for the luminance/ang.radius table,
                      rough compensation of light fall-off for Nikon990 FC-E8 
		      combination, -15 +15 midpix shift changed to -8 +19}
		{1.13 fall-off compensation works for tile luminances too;
		      strip radial table possible, 
		      in addition to a segment one introduced in 1.12}
		{1.14 can write an equidistant cylindric log-coded pgm image,
		      uses a better fall-off compensation}         
		{1.15 enlarged line size to 2000*2, ovlim can reach 65535,
		      dcraw -v -i input for E300 instead of jhead one,
		      -D# option for forced black to be subtracted}
	      {f version: 
		      minimized field sizes for fuji S5000, 
		      no Ekvidistant Image creation -- to fit a 128MB memory}	          
                {1.16 -MR and -ML works for fuji as well, 
		       overview_r2s heading possible, using -wh}
		{1.17 -- devignetting for Fuji}  
		{1.18 zero pixels disregarded for aver. luminance for Fuji}
		{1.19 should compute tile sums just within LU limits  }
		{1.20 makes a complete distribution curve}
		{1.21 -- can switch it off, as well as tile printing;
		      new switch for darkframes and cumulative numbers for them,
		      adding distribution curve integral for Fuji, 
                       correcting for non-zero darkframe averages}
		{1.22 tile-wise illuminance, luminance+SD and -FI option added}       
		{1.23 overexposure just for luminance-relevant colours,
		     zero tiles allowed (a quick help for tilted fuji frames) }
                {1.24 adding of distrib. curve integral for Fuji can be 
                     switched off (useful for subtracting two real 
                     images), adding works for blue tile luminances too,
		     colour half-sized image for Fuji can be done really
		     -- one problem was the twice lower dimension for linlhC
		         in the F version}    		               
		{1.25 not-all-colour tile illuminances computed with a 
		     weighted average of nsum[cam[j]][tile] 
		     rather then nsum[1][tile];
		     darkA set even for non-darkframed images;
		     blue nsumraw>0 tested for FujiAddInt tile application }
		{1.26 can produce luminance scale values in the *.eps file,     
		     if -LS is given (-LN switches it off)}     
                {1.27 -BM switch for Colour Ratios in LogImage}		
		{1.28 gray fullsize image, square smoothing}
		{1.29 NPS Night Sky Team colour scale option}
		{1.30 can really accept an overlimit colour, 
   	    and has a correct heading for darkframe image all-percentils}
	        {1.31 corrects an error introduced in 1.19, namely
		 nonsense median luminances within tiles if G is included
		 in the RGB linear combination
	    and adds a central tile size information to the output}
	        {1.32 correct an error of missing spaces instead of
		  an average for a tile, when n=0}    
	        {1.33 can subtract tile medians from averages, 
		  skip some *.eps output (lines, coordinates, medians)
		  and write faintness / 1 mag instead of lm/m2 or cd/m2
		  (the faintness concerns 1 square arcsecond in the 
                  latter case) }    
	        {1.34 understands exif strings of dcraw and exiftool
	         and limits a side of a square to be smoothed to 64 
                 instead of (unsaid) 32} 
		{1.35 is but expanded to grasp even the largest chip P65, 
		 8984 pixel line: a changed 'linlhc' constant}
		
 ovlim : word ={3980 d60}{8190}{60000}15850;  {this means overflow; but it's a nonsense in 
fact, it's just spilled signal from really overexposed pixels}
 trueov={4095 d60}{8191}65535 {from Jan 06}{32768 bef. Jan 06}
  {15862}{is far too low for fuji5000}
  {16916 should be enough} ;
 sideC = 32;
{ side:word = sideC ;}  {side of a monochromatic tile, chosen to match the width of 
                a shielded left band of the chip}
 sideX:word=sideC; 
 sideY:word=sideC; 
 ovlimT ='15850';
 trueovT='32768';
 sideT = '32'; 

 h10 = cl+
' raw2lum <graymap file> [options]'+cl2+
 
'writes a series of photometric tables to the standard output.' +cl2+

'The main input is a raw graymap made from a Canon D60 camera raw image *.crw'+cl;
 h20=  
'by "decompress" by David Coffin, http://www.shore.net/~dcoffin '+cl+
'or a portable graymap (*.pgm) produced by an adapted version of his "dcraw".'+cl2;

h20a=
'Auxiliary inputs can be submitted as parameters:'+cl2+

'-I <exif info file>  -- output of "jhead" by Matthias Wandel,'+cl+
'  http://www.sentex.net/~mwandel/jhead, to get exposure'+cl2;
h20b=
'-D <dark frame file>[:scaling]  -- image taken with the same shutter speed'+cl+
'  and ISO sensitivity, but with a covered lens, i.e. readings of an unlit chip,'+cl+
'  to be subtracted from the main image; the same image format is assumed'+cl;
h20bb=
'-D# a constant to be subtracted (just an emergency replacement of a dark frame)'+cl;
h20c=
'-O <offset frame file> -- dark image taken with a short exposure,'+cl+
'  to be subtracted from both mainframe and darkframe. Use it when'+cl+
'  (dark frame - offset frame) needs scaling.'+cl; 

h30=
'Optional output:'+cl2;

h30a=
'-E <eps output file> -- Encapsulated PostScript file with a grid of medians'+cl+
'  of the recorded values (just of upper left green points of the Bayer matrix)'+cl+
'  and, with known exposure, with median luminances. A command'+cl;
h40=
' composite -compose Multiply <eps file> <image file> <output image with a grid>'+cl+
'  (sw from the ImageMagick suite) will put this labeled grid onto a image,'+cl+
'  which is then easy to compare with the photometry table.'+cl2;

h41=
'-K <ppm output file> -- create a half-size image (with dark frame subtracted);'+cl+
'  for YCGM images, a guess of RGB colours which suits Nikon 990 is used'+cl+
'  (the is scaled by the second number in the -P#[:#] option, default is 4)'+cl2;

h42=
'-GI[pgm output file][:#] -- create a gray image (with dark frame subtracted);'+cl+
'  colour sensitivities are equalised according to the -MM option,'+cl+
'  (scaled as above;  :# to add afterwards, default 16)'+cl2;

h44=
'Another Color positions then 1 2  for  R G  (or another pattern...) etc.:'+cl+ 
'                             3 4       G B'+cl+

'-C{#### | fuji | YCGM}'+cl;
h44a=
'          fuji implies BRGG and RBGG for Fuji S5000,'+cl+
'                 YCGM means an alternative colours system, as for Nikon E2500,'+cl+
'   3412  would rearrange it to GMYC as for Nikon 990'+cl2;

h45=
'-T# divider to get cd/m2, default';
h46=
'-A assume arbitrary luminance scale (for uncalibrated cameras)'+cl2+
'-M#:#:#[:#] Direct multipliers of the RGB or YCGM colors get luminance, default'+cl+
'   ';

h46R=cl+
' A better way may be to define two sets of multipliers:'+cl2+

'-MR#:#:#[:#] Multipliers to get proper RGB or YCGM radiances'+cl+
'           (e.g., to force them to reach the same value for sunlight), default'+cl+
'   ';
h46L=
'-ML#:#:#[:#] Multipliers to get (some) luminance from these radiances, default'+cl+
'   ';
h46M=
'-MM#:#:#[:#] Multipliers to get another luminance from these radiances;'+cl+
'   then the ratio of luminances will be shown in the -N file. Default'+cl+
'   ';

h46a=
'-P#[:#] bitshift to diminish the pgm values, default 0,'+cl+
'   (for -K and -GI options also a number 1..255 by which the output'+cl+
'    image values should be multiplied, default 4)'+cl+
'-S#[:#] side(s) of a tile (differing Y side is optional), default '+sideT+cl2;

h46ab=
'-N<file name> make a new image with logarithmic colour-coded luminance'+cl+
'-BL#[:#] options for such colour coding --'+cl+
'   base luminance (default 0.04 mnt)'+cl+
'     : number of steps within one order of magnitude (default 5)'+cl;
h46abN=
'-NN sets the scale of Nat. Park Service Night Sky Team instead'+cl+
'  (see http://www2.nature.nps.gov/air/lightscapes/)'+cl;
h46abS=
'-LS asks for writing the scale to the postscript file given by -E'+cl+
'  (can be overriden by -LN later)'+cl;
h46ac=
'-SM[#[:#] smooth its noisy areas (-S- to avoid it, default)'+cl+
'    # 4-pixel value, below which it could be applied, default'+cl+ 
'    50,'+cl+
'       # length of a line segment or a square over which an average'+cl+
'         should be used, default 16, max. 64'+cl2; 
  
h46b=
'-G[#:#] compute veiling luminance from points in <L,U> (see below) interval'+cl+
'   assuming #:# pixel coordinates of the seeing point'+cl+
'            (default is centre of the image)'+cl;
h46c=
'-B#:# lower and upper limit of double-lines to be included in that image'+cl+
'      and computation of glare and of total flux (default is 0:infinity)'+cl+
'-W# CCDwidth / 1mm, to override ev. false Exif info'+cl+
'-WH write a heading to the overview_r2l.txt file'+cl;
h46d=
'-F<letter(s)> some further options:'+cl+
'   A for Averages instead of Medians of luminance for tiles,'+cl+
'   T for luminous flux densities from tiles rather than luminances'+cl+
'   I for illuminances from tiles'+cl;
h46e=
'   M using Medians even for T or I options (averages are default for them)'+cl+
'   L Luminances again (to reverse T or I options)'+cl+
'   F Faintness / 1 mag instead of SI units'+cl+
'     (of 1 square arcsecond, instead of luminance)'+cl;
h46f=
'   C#[:N] multiplier of focal length (# = 0.21 for Nikon FC-E8)'+cl+
'      (N demands for making no compensation of light falloff)'+cl2;


h47=
'Overful limit (before any dark level subtraction):'+cl2+ 

'-O# (default '+ovlimT+', something <=4095 suits to Canon EOS D60)'+cl+
'-O#:#:#  R:G:B for coding overfull 4pixels'+cl+
'   in colour-coded luminance image (default 255:255:255)'+cl2;           
h50=
'Summing the light just from 4-px-cells fitting some luminance limits:'+cl2+

'-L# -- lowest luminance / cd/m2'+cl+
'-U# --  upper luminance / cd/m2'+cl+
'-LM subtracts a median of a tile from its pixels above L#,'+cl+
'   (handy for stellar photometry)'+cl;

h60=
'  (when a dark frame is subtracted from an underexposed image,'+cl+
'  some pixel values may be negative, as well as the resulting "luminances",'+cl+
'  and the lower limit should be either unset or set above the noise level)'+cl2;

h70=
'R raises the values to power 1.5 (an option just for DMSP data)'+cl+
'R<filename>[:#:#] writes luminance as a function of radius (minimum and'+cl+
'               maximum azimuth / 1 degree may be added, default 0:360)'+cl;
h75=
'R<filename>:#:#:#  -- similarly, with this azimuth becoming a horizon'+cl+
'              and within the given minimum and maximum height'+cl+
'R<filename>:# makes a log-coded 8-bit pgm in equidistant cylindric projection'+cl2;

h80=
'Options for spectral calibration (for spectrum along the vertical,'+cl+
'with spectral lines being horizontal):'+cl2+

'-V<filename> sums over image lines will be stored in this text file'+cl;
h81=
'-TI#[:#] range of tiles to be included in these sums'+cl2;

h85=
'Optional comparison with *.ppm made from a jpeg or tiff format:'+cl2+

'-J<ppm file>:<output text file>[:#[:#]] -- double lines at top'+cl+ 
'  and double columns at left of the raw image to be skipped'+cl+
'  (default 1 and 4, as for Nikon990)'+cl2;
 
h90=
'Skipping some output (e.g., for successive runs with differing tile sizes):'+cl+
'-nh  no histogram'+cl+
'-np  no all percentiles output'+cl+
'-nr  append no line to the "overview_r2l.txt" file'+cl+
'-nt  no tiles printing'+cl;
h91=
'-nl  no lines in PostScript output'+cl+
'-nc  no tile coordinates in PostScript output'+cl+
'-nm  no medians in PostScript output'+cl2;


h92=
'Darkframe processing option:'+cl+
'-ni  (as "no image")'+cl2;

h100=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 2005;'+cl+
'ver.'+version+'; subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
'source code available at http://amper.ped.muni.cz/light/luminances)'+cl2;

sigma45: boolean = true;

R2Rc=2.242*1.23; {for Canon EOS D60, acc. to Dave Coffin}
B2Bc=1.245*0.86;   {... and *corrected acc. to the sunlit white paper}
R2Rs5000=1.73; {1.639  acc. to Dave Coffin}
B2Bs5000=1.57; {1.438  in dcraw}

Y2Yc=1.0; {for fish-eye Nikon 990}
C2Cc=1.06;   
Gy2Gyc=1.24;
M2Mc=1.31;

RmC=0.3; GmC=0.59; BmC=0.11; {to get the photopic luminance, 
            formula from http://www.scantips.com/lumin.html }
RmCfuji=0.35; GmCfuji=0.65; BmCfuji=0.0; {from the spectral calibration
            of Fuji S5000 for photopic luminance }
{toCdM2=33.3;  a first guess for our camera, to arrive at luminance,
              using some images of sun and moonlit snow on 2003-02-12}
toCdM2:real=56;  {a second guess for divider for our camera, to arrive at luminance,
              using another images of sunlit paper 2003-07-09,
	      1.65 times less then the first one}


{all the following coefficients (before the obsolete ap='''' 
definition) can be set by command-line parameters perhaps...}

R2R: real = R2Rc;
G2G: real = 1;
B2B: real = B2Bc;
Rm: real = RmC;
Gm: real = GmC;
Bm: real = BmC;
Rm2: real = 0;
Gm2: real = 0;
Bm2: real = 1;

Y2Y: real = Y2Yc;
C2C: real = C2Cc;
Gy2Gy: real = Gy2Gyc;
M2M: real = M2Mc;
                    
 {the following mulitipliers seem to be chosen to make a Nikon990 photopic
  luminance formula : }
Ym: real = 1.3;
Cm: real = 0;
GYm: real =-0.3;
Mm: real = 0;
Ym2:real = 0;
Cm2: real = 1;
GYm2: real =0;
Mm2: real = 0;

LumM:array[1..4] of real=(RmC,GmC,GmC,BmC);
LumMset : boolean = false;
LumRset : boolean = false;
LumLset : boolean = false;

FujiDevi: byte = 0;


ap='''';

 BitmapStart: word = 76; {for some old D60 dcraw2r output}
 BitmapStartD: word = 76; {for some old D60 dcraw2r output}
 BitmapStartO: word = 76; {for some old D60 dcraw2r output}
 BitmapStartJ: word = 76; {....}
 startline: byte = 12; {for EOS D60}
 lines: word = 1028; {double lines of D60 chip}
 tilerm: word = 33;  {lines div side + 1}
 linl: word  = 3152; {line length of D60}
 linlhC = {720 enough for fuji} {2602} 1464 {for 600D} {4491 for Phase-One P65} {1999 for E300} {1575 for D60} {linl div 2 + -1, constant just to be able to use it in 
                  declaration} ; 
 linlh:word  = linlhC {1575} {linl div 2 + -1} ; 
 {last element on the line; their number is linlh+1 = linl/2)}
{for a useful chip size lower than 3152*(2056+12), the constants may become
variables and read either from a head of *.pgm or given on a command line}

  { tilen:=(linlh+1)  div side;
   if linlh mod side = 0 then dec(tilen); 
    is number of the last tile, the first one is 0}
 tilen: word = 49 ; 
 tilenC = 99{49} ; 
 lin : word = 0;
 tiler : word = 0;
 darkn : longint = 0; 
 dark : longint = 0;
 darkStrip: boolean = true; {for D60 fully raw}
 darkDFc= 512;
 darkDF : word = darkDFc; {constant added to Main-DarkFrame to be over zero mostly}
 darkConst : byte = 0; {default dark level for individual frames}
 darkmin : word = trueov;
 darkmax : word = 0;
 min : word = trueov;
 max : word = 0;
 sumt : array [1..4] of double = (0,0,0,0);
 sumN : array [1..4] of longint = (0,0,0,0);
 sumNRaw : array [1..4] of longint = (0,0,0,0);
 maxt : array [1..4] of longint = (0,0,0,0);
 mint : array [1..4] of longint = (trueov,trueov,trueov,trueov);
 osumt : array [1..4] of longint = (0,0,0,0); {total count of outliers}
 color : array [1..4] of string[4] = ('Red ','GrUp','GrDw','Blue');
 colorY : array [1..4] of string[4] = ('Yell','Cyan','Gree','Mage');
 percn = 6;
 percv : array [1..percn] of byte = (1,10,50,90,99,100);
 dist : array [1..4] of longint = (0,0,0,0);
 lsum : {array [1..4] of }double{longint} = {(}0{,0,0,0)};
 ilsum : double=0;
 ilSQMsum : double=0;
 kf   : array [1..4] of byte = (1,1,1,1);
 k100   : array [1..4] of byte = (1,1,1,1);
 exp_length : real =0;
 exp_frac : word =0;
 exp_fracR : real =0;
 foc_ratio : real =0;
 ISO : word = 0;
 exposure : real = 1;
 exposure_known : boolean = false;
 OutputFile: string = '';
 InfoFile: string = '';
 MainFrame: string = '';
 DarkFrame: string = '';
 OffsetFrame: string = '';
 EpsFile: string = '';
 ppmFrame: string = '';
 ParFlag: char = ' ';
 SubDF: boolean = false;
 SubOffset: boolean = false;
{imin: array [1..4] of word = (0,0,0,0);
 imax: array [1..4] of word = (trueov,trueov,trueov,trueov);
 iminG: array [1..4] of word = (0,0,0,0);
 imaxG: array [1..4] of word = (trueov,trueov,trueov,trueov);
 }
 minLC=-1e4; {negative value is here just for having no real lower limit} 
 maxLC=1e5;  {upper luminance limit/ cd/m2, thrice the sunlit white paper}
 minL:real=minLC; {negative value is here just for having no real lower limit} 
 maxL:real=maxLC;  {upper luminance limit/ cd/m2, thrice the sunlit white paper}
 shrB: byte = 0;  {bitshift to compensate for dcraw standard shift}
 cam : array [1..4] of byte = (1,2,3,4); {RGGB for Canon D60}
 camM : array [1..4] of real = (1,1,1,1); {RGGB or YCGM multipliers to get white}
 fuji : boolean = false;  {just for fuji S5000}
 fuji2: byte = 1; {fuji false colour image should have 2* longer lines} 
 YCGM : boolean = false;
 bytesPP: byte=2; {bytes per pixel, default 2} 
 SumGlare: boolean = false;
 VeiLum: real = 0;
 DoublePixSize: real = 0.0147; {D60 size}
 D60ThumbExif: boolean = false;
 CCDwidth:real =0;
 CCDw:real =0; {overrides the exif info by command line parameter}
 TrueFocalLength:real = 0;
 ConvertFocus:real = 0;
 PixAngSizeKnown: boolean = false;
 SeePX:real = 0;
 SeePY:real = 0;
 colorsN = 9;
 shadesN = 5; {means number of steps within a single color in fact}
 stepsNm1c = colorsN*shadesN -1;
 stepsNm1: byte = stepsNm1c;
 BaseLum:real=0.00004; {then the colour limits are almost 
  at sqrt(10)*10^n and reach
  from just a bit polluted sky to sunlit snow
  (almost: sqrt(10)=3.162277660168379332
   whereas the formulas
           LogLR:=(ln(L)-ln(BaseLum))/lnstep;
           if LogLR>stepsNm1 then LogLR:=stepsNm1;
	   LogL:=round(LogLR);
   mean that L=        
  	            3.1773 
   rounds still down to the lower colour 
  }
 BaseLumMin:real=0.000031774; {was 3...e-4 for 2s-max exposures}
   
 colorLog: array [0..colorsN-1,1..3] of byte =
((2,1,0), (0,0,2), (2,0,2), ( 0,2,2), ( 2,0,0),
( 0,2,0), (2,2,0), (0,1,2), ( 2,2,2));
{ orange   blue    magenta    cyan      red    
  green  yellow  blue2Green  white }
 pow2m1: array [0..shadesN-1] of byte = (66,92,130,182,255);
 MakeLogImage:boolean = false;
 MakeColourImage:boolean = false;
 MakeGrayImage:boolean = false;
 LogImage:string= '';
 ColourImage:string= '';
 GrayImage:string= 'gray.pgm';
 DoTiles:boolean = true;     {false for skipping tiles and epsfile}
 DoPrintTiles:boolean = true; {false for printing tiles}
 PrintHistogram: boolean = true; {false for skipping histogram}
 PrintAllPercentils: boolean = true; {false for skipping it}
 nondark: boolean = true; {can be set to false for dark frames}
 LinMin:word=0;
 LinMax:word=0;
 Medians:boolean=true;
 Luminance:boolean=true;
 LFdensity:boolean=false;
 CommandLine:string = '';
 NonLinear: boolean=false; {NonLinear=true just for DMSP data in ver<=1.10}
 sumL : array [1..4] of double = (0,0,0,0);
 minvL : array [1..4] of word = (trueov,trueov,trueov,trueov);
 maxvL : array [1..4] of word = (0,0,0,0);
{ minvLt : array [1..4,0..tilenC] of word = (trueov,trueov,trueov,trueov);
 maxvLt : array [1..4,0..tilenC] of word = (0,0,0,0);
} tilemin: byte = 23;
 tilemax: byte = 25;
 SpLl: word = 96;
 spectrum: boolean = false;
 OutSpF: string = ''; OutRaF: string = ''; OutJpF: string = ''; 
 StepsTo10: byte=5; {standard luminance steps of 10^(1/5)}
 ScaleChanged: boolean=false;
 NonCalibrated: boolean=false; 
  {if real luminances are not known, should be true}
 Smooth: boolean = false;
 smoothL:byte=16;
 smoothV:word=50;
 smoothLmax = 64;
 ColourScale:byte=4;
 ScaleDark:real=1;
 CentreSee:boolean=true;
 AppResults:boolean=true;
 ln10 = 2.302585093;
 NoOverColour:boolean=true;
 OverColour:array [1..3] of byte = (255,255,255);
 Radial:boolean=false; RMcrad=199; 
 AzMax:real=2*pi; AzMin:real=0;
 Segment:boolean=false; 
 jpeg_compare:boolean=false;
 DcolLeftSkip:byte=4; {double lines to skip in raw image to match the jpeg one}
 DlinUpSkip:byte=1; {double columns to skip at left edge to match... Nikon990}
 FlatFielding:boolean=false;
 NoFlatFielding:boolean=false;
  {options for a strip radial table output:}
 CentralAz:real=0;
 HeiMinRad:real=-0.1;
 HeiMaxRad:real=0.1;
 AzMinRad:real=0;
 AzMaxRad:real=2;
 Strip:boolean=false; {no strip}
  {end of the strip defaults}
 EkvidistImage:boolean=false;
 EkvidistImageName:string='';
 EkvXmax=2399{1};
 EkvXH=1200;
 OverwHead: boolean = false; 
         {write a heading to an overview_r2l file, switched on by -wh}
 F100: word = 100; {angles per radian, for radial output}
 percvalsum : array [1..4] of longint = (0,0,0,0);
 iLsumT: double = 0;
 LsumT: double = 0;
 LsumQ: double = 0;
 Tcount: word = 0;
 FujiAddInt: boolean = true;
 EpsLumScale: boolean = false;
 TwoColour: boolean = false;
 EpsFileTiles: boolean = false;
 SmoothSquare: boolean = true;
 lineL: byte = 0;
 LumNoise: real = 1e-5;
 LumNoiseSet: boolean = false;
 BlackLevel: integer = 16;
 SubMed: boolean = false;
 Faintnesses : boolean = false;
 ZeroMag = 2.54e-6;
 EpsFileLines : boolean = true;
 EpsTileNumbers : boolean = true;
 EpsTileMedians : boolean = true;
 sec = Pi/180/3600; 
 Qsec=sec*sec;
 
NPSscaleLength = 46;
{for compatibility sake: a guess of NPS Night Sky Team scale:}
 NPSscale : array [0..NPSscaleLength-1,1..3] of byte = (
 (30,0,0),
 (60,0,0),
 (60,0,25),
 (70,0,60),
 (105,0,105),
 (75,0,125),
 (40,0,140),
 (15,0,145),
 (25,35,170),
 (25,75,175),
 (0,100,175),
 (0,120,180),
 (0,135,180),
 (0,160,180),
 (0,190,190),
 (0,200,160),
 (30,210,140),
 (0,205,20),
 (95,205,0),
 (155,205,0),
 (185,205,0),
 (210,225,0),
 (215,215,0),
 (220,205,0),
 (210,185,0),
 (215,155,0),
 (230,135,0),
 (235,120,0),
 (230,100,0),
 (230,80,0),
 (230,50,0),
 (224,0,0),
 (224,0,63),
 (220,0,85),
 (230,0,128),
 (230,0,185),
 (215,0,215),
 (220,95,210),
 (225,125,205),
 (225,155,215),
 (215,190,215),
 (232,225,250),
 (228,235,250),
 (232,254,253),
 (235,255,240),
 (255,255,255) );
 colourNPSscale: boolean = false;
 
var
 f,fd,fo,fj,LogImFile, ColImFile, GrayImFile : file; 
 f1t, OutSp : text;
 draw: text;
 fdesc : text;
 v,vRaw : array [1..4] of word;
 vD : array [1..4] of word;
 vO : array [1..4] of word;
 o : array [1..4] of boolean;
 sum : array[1..4,0..tilenC] of longint;
 nsum                            : array[1..5,0..tilenC] of word{integer};
 {nsum,}nsumRaw, minv, maxv, osum : array[1..4,0..tilenC] of word{integer};
 his : array [1..4,0..trueov] of longint;
 hisd : array [1..4,0..trueov] of longint;
 hist : array [1..4,0..trueov,0..tilenC] of longint; {for one row of tiles only}
 line1,
 line2, 
 lineD1, 
 lineD2, 
 lineO1, 
 lineO2 : array [0..linlhC,1..2] of word;
 line1B : array [0..linlhC,1..2] of byte absolute line1;
 line2B : array [0..linlhC,1..2] of byte absolute line2;
 line1J : array [0..linlhC,1..6] of byte;
 line2J : array [0..linlhC,1..6] of byte;
 lineD1B : array [0..linlhC,1..2] of byte absolute lineD1;
 lineD2B : array [0..linlhC,1..2] of byte absolute lineD2;
 lineO1B : array [0..linlhC,1..2] of byte absolute lineO1;
 lineO2B : array [0..linlhC,1..2] of byte absolute lineO2;
 tile, j, jj, k, LogL, iS: byte;
 i,jw : word; 
 count, overdark : longint;
 perc : array [1..4,1..percn] of longint;
 perc100 : array [1..4,1..118] of longint;
 percval : array [1..4,1..percn] of word;
 percvalall : array [1..4,1..118] of word;
 tline, auxstr, Par, ParOrig, ParOrig1, ImDate, ImTime, ImName, tlineC: string;
 tline13: string [13];
 L,L2,R,G,B, Y,C,GY,M,
 tolumflux,FourPixSA,FourPixXS,FourPixYS,XpToD,YpToD,
 SpaceAngle,LogBase,lnStep,LogLR,tolum,R2T,G2T,B2T,Y2T,C2T,M2T,
 R2T2,G2T2,B2T2,Y2T2,C2T2,M2T2,
 DarkFloat,DarkE,Dark2,SqAngDist,BaseLumNew, auxreal: real;
 {FoundName: PathStr;} FDir: DirStr; FName: NameStr; FExt: ExtStr;
 nonzero, Overfull, InLines, TrueOverfull, BelowMinL, OverMaxL, 
  InSegment, Segment2pi, Smoo: boolean;
 auxint,twoI: integer;
 auxword: word;
 LogCol : array [0..linlhC+10,1..3] of byte;
 ColCol : array [0..linlhC,1..3] of word;
 GrayCol : array [0..1,0..linlhC*2+1] of word;
 sumLt : array [1..4,0..tilenC] of longint;
 {the following 3 lines are for the smooth option:}
  AverPix : array [0..linlhC] of longint; 
  L_i : array [0..linlhC] of real; 
  L_i2 : array [0..linlhC] of real; 
  noiseL,LogColS:byte;
  LogLine : array [1..smoothLmax,0..linlhC+10,1..3] of byte;
  AverPixLine : array [1..smoothLmax,0..linlhC] of longint;
  L_Line : array [1..smoothLmax,0..linlhC] of real;
  L_Line2 : array [1..smoothLmax,0..linlhC] of real;
 R2, G2, B2, Y2, C2, M2: array [1..3] of real;  
 FromMid, FromMidRad, FromMidDeg, FromMidAz, FromMidAreaMag, 
  FromMidCos, FromMidSQM, FromMidColurAz, FromMidHeight,
  SeePR, SeepAZ: real;
 MidPixX, MidPixY, FromMidPix: word;
 rlsum: array[0..RMcrad] of double ; rlcount:array[0..RMcrad] of longint;
 rlsumQ: array[0..RMcrad] of double;
 linesJ: word; {double lines of ppm made from a jpeg}
 linlJ,linlJh: word;  {line length of ppm}
 jp_count: array [1..4,0..16383] of longint;
 jp_sum:  array [1..4,0..16383,1..3] of double;
 jp_v: array [1..3] of word;
 EkvidistImageVal:array[0..EkvXmax,0..1899] of real;
 EkvidistImageCount:array[0..EkvXmax,0..1899] of byte;
 EkvidistImagePix:array[0..EkvXmax] of byte;
 Ex,Ey:word; EMaxLuminance,EMaxLuminanceLn,csingle, LFDen:real;
 ExD,EyD,ExO,EyO,ij,ik:integer;
 FujiAdd: array[1..4,0..80] of byte;
 lcc: array [1..4] of boolean;

procedure help;
begin
 write(h10,h20,h20a,h20b,h20c,h30,h30a,h40,h41,h42,h44,h44a,
  h45,toCdM2:6:1,cl,h46);
 if YCGM then 
  {Nikon 990}
  write(Y2Yc*Ym:6:3,C2Cc*Cm:6:3,Gy2Gyc*GYm:6:3,M2Mc*Mm:6:3)
 else
 if fuji then
  {Fuji S5000} 
  write(R2Rs5000*RmCfuji:6:3,GmCfuji:6:3,B2Bs5000*BmCfuji:6:3)
 else
  {Canon EOS D60}
  write(R2Rc*Rm:6:3,Gm:6:3,B2Bc*Bm:6:3);

 write(cl,h46R);
 if YCGM then 
  {Nikon 990}
  write(Y2Yc:6:3,C2Cc:6:3,Gy2Gyc:6:3,M2Mc:6:3)
 else
 if fuji then
  {Fuji S5000} 
  write(R2Rs5000:6:3,'  1.00',B2Bs5000:6:3)
 else
  {Canon EOS D60}
  write(R2Rc:6:3,'  1.00',B2Bc:6:3);

 write(cl,h46L); 
 if YCGM then 
  {Nikon 990}
  write(Ym:6:3,Cm:6:3,GYm:6:3,Mm:6:3)
 else
 if fuji then
  {Fuji S5000} 
  write(RmCfuji:6:3,GmCfuji:6:3,BmCfuji:6:3)
 else
  {Canon EOS D60}
  write(Rm:6:3,Gm:6:3,Bm:6:3);

 write(cl,h46M); 
 if YCGM then 
  {Nikon 990}
  write(Ym2:6:3,Cm2:6:3,GYm2:6:3,Mm2:6:3)
 else
  write(Rm2:6:3,Gm2:6:3,Bm2:6:3);

 write(cl2,h46a,h46ab,h46abN,h46abS,h46ac,h46b,h46c,h46d,h46e,h46f,
 h47,h50,h60,h70,h75,h80,h81,h85,h90,h91,h92,h100); halt;
end;

function MagSqSec(JS:real):real;
begin
 MagSqSec:=-2.5*ln(JS*Qsec/ZeroMag)/ln10
end;

procedure zerosums;
begin
 sum[j][tile]:=0 ; nsum[j][tile]:=0; nsumRaw[j][tile]:=0;
 minv[j][tile]:=trueov; maxv[j][tile]:=0; osum[j][tile]:=0;
end;

 procedure CalcFromMid(xpx,ypx:real);
 var xMid,yMid: real;
  begin
   {angular:}
   xMid:=FourPixXs * -(MidPixX - xpx);
   yMid:=FourPixYs * (MidPixY - ypx);
   C2_to_P(xMid,yMid,FromMid,FromMidAz);

   {pixel-width number:}
   xMid:= -(MidPixX - xpx);
   yMid:=  (MidPixY - ypx);
   if fuji then yMid:= yMid/2;
   FromMidPix:= round(sqrt(sqr(xMid)+sqr(yMid)));

   if ConvertFocus<0.4 {FishEye} then 
    begin {Nikon 990 short focus + E8 fish-eye convertor}
     auxreal:=FromMid / 2.4;
     if auxreal<0.717 then
      FromMidRad:=2.4*arctan(auxreal / sqrt(1 - sqr(auxreal)))
      {1.91877 rad = 109.9376559 degrees maximum}
     else FromMidRad:=0.63*pi; {set to 113.4 degrees, 3 more than above}   
     if (auxreal>0.01) then	 
      FromMidAreaMag:=1.2*sin(FromMidRad/1.2)/sin(FromMidRad)		 
     else FromMidAreaMag:=1;   
    end
   else 
   if sigma45 then
    begin {sigma 4.5 mm}
     auxreal:=FromMid / 2;
     if auxreal<0.7072 then
      FromMidRad:=2*arctan(auxreal / sqrt(1 - sqr(auxreal)))
      {1.91877 rad = 109.9376559 degrees maximum}
     else FromMidRad:=0.63*pi; {set to 113.4 degrees, 3 more than above}   
     FromMidAreaMag:=1;   
    end
   else
    begin {Nikon 990 short focus}
     auxreal:=FromMid / 1.4;
     FromMidRad:=1.4*arctan(auxreal);
     if (auxreal>0.01) then	 
      FromMidAreaMag:=1.4*sin(FromMidRad/1.4)/sqr(cos(FromMidRad/1.4)) 
                      / sin(FromMidRad)
     else FromMidAreaMag:=1;   
    end;
   FromMidCos:=cos(FromMidRad); 
                           xmid:=sqr(FromMidRad);
   FromMidSQM:= exp(-(0.5* xmid + 2.25* sqr(xmid)) *ln10 / 2.5);
   FromMidDeg:=rad_to_deg(FromMidRad);
   FromMidColurAz:=FromMidAz + pi/2 - CentralAz;
   FromMidHeight:=pi/2 - FromMidRad;
   Ah2td(FromMidColurAz,FromMidHeight);
  end;

function EkvidistXY: boolean;
  {computation of X and Y, false if outside the frame}
var auxboo:boolean; AuxI: integer;
 begin
      auxboo:=true;
      auxI:=round(rad_to_deg(FromMidColurAz)*10);
      if auxI>1800 then dec(auxI,3600);
      inc(auxI,EkvXH);
      if auxI<0    then auxboo:=false;
      if auxI>EkvXmax then auxboo:=false;
      if auxboo then 
       begin
        Ex:=auxI;
        auxI:=round(950 - rad_to_deg(FromMidHeight)*10);
        if auxI<0    then auxboo:=false;
        if auxI>1899 then auxboo:=false;
        if auxboo then Ey:=auxI;
       end;
      EkvidistXY:=auxboo; 	 
 end;

function DeVign:real;
var x,DeVi:real;
 const
{  a = 1.0732      ;
  b = -0.00144467 ;
  c = -0.0701781  ;}
{a               = 1.06743     ;
b               = -0.00152186  ;   
c               = -0.0634556    ;}

a=1;
b = -0.0937959;  
c = 0.844643;   

afs              = 1.0079    ;
bfs              = -0.000255331 ;
cfs              = -0.000185811 ;
Sfs =105;

afm              = 1.00733 ;    
bfm             = -0.000109419 ;   
cfm               = -0.000370727 ;   
dfm               = 1.22305e-06   ;
Sfm =121;

Sfl=39 ;
Sfl2=145 ;
afl              = 1.00502;
bfl             = -0.00243771  ;
cfl               = -3.1987e-05  ;
dfl               = 1.38421e-07;
efl              = -0.00018012 ; 

as= -9.6619; 
bs= 19.082 ;
cs=-12.07 ;
ds=  1.5323; 
es=  0.5931 ;
fs= -0.1051 ;

 begin
 DeVign:=1;
 if fuji then
  begin
   x:=FromMidPix/3;
   DeVi:=1;
   case FujiDevi of
   1: 
    begin
     DeVi:=afs + bfs*x ;
     if x>Sfs then
      DeVi:= DeVi + cfs*sqr(x-Sfs);
    end;  
   2:
    begin
     DeVi:=afm + bfm*x ;
     if x>Sfm then
      DeVi:= DeVi + cfm*sqr(x-Sfm) + dfm*sqr(x-Sfm)*(x-Sfm);
    end;  
   3: 
    begin
     DeVi:=afl ;
     if x>Sfl then
      DeVi:= DeVi + bfl*(x-Sfl) + cfl*sqr(x-Sfl) + dfl*sqr(x-Sfl)*(x-Sfl);
     if x>Sfl2 then
      DeVi:= DeVi + efl*sqr(x-Sfl2);
    end
   end;     
   DeVign:=DeVi;
  end
 else if sigma45 then
  begin
   x:=FromMidPix/722;
   if x<=1 then
    DeVign:= (((((as*x + bs)*x + cs)*x + ds)*x + es)*x + fs)*x + 1;
  end
 else  {nikon 990 FC-E8 fish eye}
  DeVign:= a  + b / cos(FromMidRad*c)  - b
 end; 



procedure printTiles;
var xpix, ypix, darkDFor0 : word;
 darkA : real; {darkA is a changing estimate of dark 
                   during processing the tiles, for DarkStrip}
 overfullTile:boolean;		   
 nsumw : real; {weighted nsum, by Rm etc.}
 
 
begin

inc(tiler);

ypix:= lines*2 - ((tiler-1)*sideY*2+sideY);

for tile:=0 to tilen do
begin
CalcFromMid(tile*sideX +sideX/2,lin - sideY/2);
overfullTile:=false;
xpix:=(tile)*sideX*2+sideX;
if DarkStrip then dec(xpix,64);  {64 pixels hold just for D60!}     
if nsum[5][tile] = 0 then overfullTile:=true;
for j:=1 to 4 do
 begin
  count:=nsum[j][tile]+osum[j][tile];
  for k:=1 to percn do {this could be done ahead, as there are just  
    4 types of tiles, but in principle defect pixels could be excluded
    in the future}
   begin
    perc[j][k]:=trunc(0.01*percv[k]*count);
   end;    
  for i:=minv[j][tile] to maxv[j][tile] do
   begin
{write(i:4,j:2,tile:3,hist[j,i,tile]:3);}
    inc(dist[j], hist[j][i][tile]);
{writeln(dist[j]:5);    }
    if kf[j]<=percn then
    if dist[j]>=perc[j][kf[j]] then 
     begin
      percval[j][kf[j]]:=i;
      inc(kf[j]);
     end; 
   end;
  while kf[j]<=percn do {for case of max-min < percn}
   begin
    percval[j][kf[j]]:=i;
    inc(kf[j]);
   end; 
 end;  
fillchar(kf,4,1);
fillchar(dist,4*4,0);

    {if DoPrintTiles then}
     begin
      if SubDF then darkDFor0:=darkDF else darkDFor0:=0; {before epsfile writing,
        no value is subtracted from the data, in case of no dark frame,
	raw pgm values are reported}
      if DoPrintTiles then 
       write(tiler:2, tile:3, nsum[1][tile]+osum[1][tile]:5);
      for k:=1 to 4 do 
       begin
        j:=cam[k];
        if DoPrintTiles then 
         write(minv[j][tile] - darkDFor0 :6);
        if nsumRaw[j,tile] > 0 then
	  begin
          if DoPrintTiles then 
           write((sum[j][tile] - darkDFor0 * nsum[j][tile]) 
	          div nsumRaw[j][tile] : 6)
          end		  
	else	  
          if DoPrintTiles then write('      ' {sum[j][tile] : 5}); {is equal to zero}

	  if DarkStrip and (tile=0) then 
	   begin 
	    inc(dark,sum[j,tile]); inc(darkN,nsum[j,tile]);
            if minv[j][tile] < darkmin then darkmin:=minv[j][tile];
            if maxv[j][tile] > darkmax then darkmax:=maxv[j][tile];
	   end
	  else
	   begin
	    sumt[j]:=sumt[j]+sum[j,tile]; inc(sumN[j],nsum[j,tile]);
	    inc(sumNRaw[j],nsumRaw[j,tile]);
            if minv[j][tile] < mint[j] then mint[j]:=minv[j][tile];
            if maxv[j][tile] > maxt[j] then maxt[j]:=maxv[j][tile];
	   end;     
        if (tile>0) or (not DarkStrip) then  inc(osumt[j],osum[j][tile]);
        if DoPrintTiles then 
         write(maxv[j][tile]-darkDFor0:6, osum[j][tile]:6);

       end; 
      if DoPrintTiles then 
       writeln; 
    end;
    
      if exposure_known then
       begin
        if (not SubDF) then 
	 if (DarkStrip) then
          darkA:=dark / darkN
	 else 
	  darkA:=DarkDFor0 
        else 
	  darkA:=darkDF;
   	if Medians then  
	if YCGM then
	   L:=(Y2T*(percval[cam[1]][3] - darkA) 
              +C2T*(percval[cam[2]][3] - darkA)
	      +G2T*(percval[cam[3]][3] - darkA)
              +M2T*(percval[cam[4]][3] - darkA) 
	      ) 
	else
 	  L:=
	   R2T*(percval[cam[1]][3] - darkA) +
	  {G2T*(percval[cam[2]][3]+perc[cam[3]][3] - 2*darkA ) +
                      was here in 1.19 to 1.30 -- nonsense median luminances }
	   G2T*(percval[cam[2]][3]+percval[cam[3]][3] - 2*darkA ) +
	   B2T*(percval[cam[4]][3] - darkA)
	else if (not overfullTile) and
	  ((nsumRaw[cam[1]][tile] >0) and
	   (nsumRaw[cam[2]][tile] >0) and
	   (nsumRaw[cam[3]][tile] >0) and
	   (nsumRaw[cam[4]][tile] >0) )
	 then {averages}
	if YCGM then
	   L:=(Y2T* ((sum[cam[1]][tile] - darkA * nsum[cam[1]][tile]) 
	              / nsumRaw[cam[1]][tile] ) 
              +C2T* ((sum[cam[2]][tile] - darkA * nsum[cam[2]][tile]) 
	              / nsumRaw[cam[2]][tile] )
	      +G2T* ((sum[cam[3]][tile] - darkA * nsum[cam[3]][tile]) 
	              / nsumRaw[cam[3]][tile] )
              +M2T* ((sum[cam[4]][tile]- darkA * nsum[cam[4]][tile]) 
	              / nsumRaw[cam[4]][tile] ) 
	      )  
	else
 	  L:=
	   R2T*((sum[cam[1]][tile] - darkA * nsum[cam[1]][tile]) 
	              / nsumRaw[cam[1]][tile] ) +
	   G2T*((sum[cam[2]][tile] - darkA * nsum[cam[2]][tile]) 
	              / nsumRaw[cam[2]][tile] +
	        (sum[cam[3]][tile] - darkA * nsum[cam[3]][tile]) 
	              / nsumRaw[cam[3]][tile]) + 
	   B2T*((sum[cam[4]][tile] - darkA * nsum[cam[4]][tile]) 
	              / nsumRaw[cam[4]][tile] )
	else L:=0;   

        if fuji and SubDF and FujiAddInt 
	and(nsumRaw[cam[1]][tile] >0) and
	   (nsumRaw[cam[2]][tile] >0) and
	   (nsumRaw[cam[3]][tile] >0) and
	   (nsumRaw[cam[4]][tile] >0) 
	then  {enlarging luminaces for medians 10 to 100}
        begin
	 auxint:=round((sum[cam[1]][tile] - darkA * nsum[cam[1]][tile]) 
	              / nsumRaw[cam[1]][tile] );
	 if auxint > 80 then 
          L:= L + R2T * FujiAdd[1,80]
         else if auxint>0 then 
	  L:=L + R2T * FujiAdd[1,auxint];
	 for j:=2 to 3 do
	 begin
	 auxint:=round((sum[cam[j]][tile] - darkA * nsum[cam[j]][tile]) 
	              / nsumRaw[cam[j]][tile] );
	 if auxint > 80 then 
          L:= L + G2T * FujiAdd[j,80]
         else if auxint>0 then 
	  L:=L + G2T * FujiAdd[j,auxint]
	 end; 
	 auxint:=round((sum[cam[4]][tile] - darkA * nsum[cam[4]][tile]) 
	              / nsumRaw[cam[4]][tile] );
	 if auxint > 80 then 
          L:= L + B2T * FujiAdd[4,80]
         else if auxint>0 then 
	  L:=L + B2T * FujiAdd[4,auxint];
        end;

        if SubMed 
	and(nsumRaw[cam[1]][tile] >0) and
	   (nsumRaw[cam[2]][tile] >0) and
	   (nsumRaw[cam[3]][tile] >0) and
	   (nsumRaw[cam[4]][tile] >0) 
	then  {subtracting median}
        begin
	 L:=L - R2T * (percval[cam[1]][3]-darkDFor0);
	 for j:=2 to 3 do
	 begin
 	  L:=L - G2T * (percval[cam[j]][3]-darkDFor0);
	 end; 
	 L:=L - B2T * (percval[cam[4]][3]-darkDFor0);
        end;

        if FlatFielding and (FromMidDeg<95) then
         L:=L/DeVign; 
       end;

    if FromMidCos>0 then
     iLsumT:= iLsumT 
      + FourPixSA*L*(nsum[1][tile]) * FromMidCos / FromMidAreaMag;
    LsumT:= LsumT + L;
    LsumQ:= LsumQ + sqr(L);
    inc(Tcount);

    if YCGM then
     nsumw:= nsum[cam[1]][tile]*Ym +  nsum[cam[2]][tile]*Cm + 
     nsum[cam[3]][tile]*GYm +  nsum[cam[4]][tile]*Mm
    else
     nsumw:= nsum[cam[1]][tile]*Rm 
          + (nsum[cam[2]][tile] + nsum[cam[3]][tile])*Gm*0.5 
    	  +  nsum[cam[4]][tile]*Bm;


    if DoPrintTiles then
     begin
      if (tile>0) or (not DarkStrip) then  
      if (L <> 0.00) then 
        if Luminance then
	 if Faintnesses then
          write('  ',SRxb(2,MagSqSec(L),8))  {luminance for a lit tile}
	 else
          write('  ',SRxb(2,L,8))  {luminance for a lit tile}
	else if LFdensity then {luminous flux density from a tile}
	 begin
	  LFden:=FourPixSA*L * nsumw
	                     / FromMidAreaMag;
	  if Faintnesses then
           if LFDen>0 then    	  
	    write('  ',SRxb(2,-2.5*ln(LFDen/ZeroMag)/ln10,8)) 
	   else write('  !',SRxb(2,LFden,7))    
	  else
	   write('  ',SRxb(2,LFden,8)) 
         end			     
        else {illuminance}			     
	  write('  ',SRxb(2,FourPixSA*L * nsumw
	        * FromMidCos / FromMidAreaMag,8)) 
      else
        write('          ');
      for j:=1 to 4 do
       write(percval[cam[j]][2]-darkDFor0:6, 
             percval[cam[j]][3]-darkDFor0:6, 
	     percval[cam[j]][4]-darkDFor0:6, nsumRaw[j][tile]:6);
      writeln;
     end;
        
      if YCGM then j:=cam[1] {Y} else j:=cam[2]; {G}         
      if EpsFile<>'' then
      if ((tile>0) or (not DarkStrip))
      and (tiler<tilerm) then
       if tile<tilen then  
        begin
	if EpsFileTiles and (not(EpsLumScale) or (tile<tilen-1)) then
	begin
         if (Luminance)
	 or ((not Luminance) and (L <> 0.00))
	  then write (draw,
            xpix:4,ypix:5,' m (',
            tiler:2,') (',tile:3,') (',percval[j,3]-darkDFor0:5,') sc ' );
         if exposure_known then
	 if (L <> 0.00) then
          if Luminance then
 	   if Faintnesses then
           write(draw,
	    '(',SRx(2,MagSqSec(L)),') sl ')
	   else
           write(draw,
	    '(',SRx(2,L),') sl ')
          else
 	  if LFdensity then{luminous flux density from a tile}
	   begin
	    LFden:=FourPixSA*L * nsumw
	                     / FromMidAreaMag;
	    if Faintnesses then
             if LFDen>0 then    	  
  	      write(draw,'(',SRx(2,-2.5*ln(LFDen/ZeroMag)/ln10),') sl ')
	     else     
  	      write(draw,'(!',SRx(2,LFDen),') sl ')
	    else
	     write(draw,
	    '(',SRx(2,LFDen),') sl ')
           end			     
          else {illuminance}
	   write(draw,
	    '(',SRx(2,FourPixSA*L * nsumw
	              * FromMidCos / FromMidAreaMag),') sl ');
         if (tile mod 2) = 1 then  {2 tiles per line}
          writeln(draw);
	end  
        end
       else {last tile, uncomplete one, plotting the horizontal line instead}
        if EpsFileLines then
         writeln(draw,
         ' 0 ',ypix-sideY:5,' m ',linl-1:5,ypix-sideY:5,' ls');

    for j:=1 to 4 do 
        zerosums;      
    nsum[5][tile]:=0;	

     end; { of  for tile:=0 to tilen do}

    fillchar(hist,4*4*(trueov+1)*(tilenC+1),0);
   end;

procedure captions;
 begin
        {33 49   32   137  133  142    0   147  144  153    0   149  146  155    0   145  140  149    0
}
if DoPrintTiles then
begin
 if YCGM then
  writeln(cl,'#c li count  min   Yav   max  ovf   ',
                     'min  Cav    max   ovf   ',
		     'min  Gav    max   ovf   ',
		     'min  Mav   max   ovf')
 else		     
  writeln(cl,'#c li count  min   Rav   max  ovf   ',
                     'min  G1    max   ovf   ',
		     'min  G2    max   ovf   ',
		     'min  Bav   max   ovf');
  writeln(   '#percentils   10    50    90  #>0  etc.');	     

if exposure_known then
 if Medians then
  if Luminance then   
   writeln('# Median Luminance / 1 cd.m-2')
  else 
   writeln('# Median Luminous flux density (Brightness) / 1 lm.m-2')
 else 
  if Luminance then   
   writeln('# Average Luminance / 1 cd.m-2')
  else 
   writeln('# Average Luminous flux density (Brightness) / 1 lm.m-2');
end; {of if DoPrintTiles}

if EpsFile<>'' then
 begin
 EpsFileTiles:= not TwoColour;
 assign(draw,EpsFile);
 rewrite(draw);
 write(draw,
'%!PS-Adobe-3.0 EPSF-3.0',cl,
'%%BoundingBox: 0 0 ');
if DarkStrip {Canon D60 full, ppm needs smaller size} then 
 write(draw,' 3086')
else
 write(draw,linl:5);
if fuji 
then writeln(draw,lines:5,cl) {fuji jpg has really halved number of lines}
else writeln(draw,lines*2:5,cl);
 {but for Canon D60 full, ppm made by dcraw has two rows less...}

 writeln(draw, cl,
'% Results of "raw2lum" (version ', version,') with parameters:',cl,
'% ',CommandLine,cl);



writeln(draw, 
'/m {moveto} def',cl,
'/ls {lineto stroke} def',cl,
'/s {dup stringwidth 2 div exch 2 div neg exch rmoveto show} def',cl,
'/scf  {gsave 0 ',-(8*sideY) div sideC,' rmoveto L s grestore',cl,
'     gsave  0 ',(20*sideY) div sideC,' rmoveto s grestore',cl,
'     gsave ',-(30*sideX) div sideC,' ',(10*sideY) div sideC,' rmoveto show grestore} def',cl,
'/sl {0 ',(-28*sideY) div sideC,' rmoveto l s} def',cl2,

 
'/L {/Helvetica ',(16*sideY) div sideC,' selectfont} def',cl,
'/l {/Helvetica ',(14*sideY) div sideC,' selectfont} def',cl,
'l',cl);

if EpsTileNumbers then
 writeln(draw, 
 '/sc {scf} def',cl,
 '/scm  {gsave 0 ',-(8*sideY) div sideC,' rmoveto L s grestore',cl,
 '     pop',cl,
 '     pop} def',cl)
else
if EpsTileMedians then
 writeln(draw, 
'/sc  {gsave 0 ',-(8*sideY) div sideC,' rmoveto L s grestore',cl,
'     pop',cl,
'     pop} def',cl)
else
 writeln(draw, 
'/sc  {pop',cl,
'     pop',cl,
'     pop} def',cl);



if fuji then writeln(draw,'1 0.5 scale',cl);

if DarkStrip then k:=1 else k:=0;
 if EpsFileLines then
 for tile:=k to tilen do
  begin  {plotting vertical lines}
   write(draw,
            tile*SideX*2:5,' 0 m',tile*SideX*2:5,lines*2-2:5,' ls');
   if (tile mod 20) = 0 then {20 tiles per line}
       writeln(draw);
  end;
 writeln(draw); 
 if SumGlare then 
  writeln(draw, 'gsave 3 setlinewidth',
          seepx*2-10:5:0,(lines-seepy)*2:5:0,' m', 
	  seepx*2+10:5:0,(lines-seepy)*2:5:0,' ls',    
          seepx*2:5:0,   (lines-seepy)*2-20:5:0,' m', 
	  seepx*2:5:0,   (lines-seepy)*2+20:5:0,' ls',
	  ' grestore' );
 end; {of creating the beginning of EpsFile} 

 end;

function PGMbaseinfo: boolean; {skipping comments and empty lines}
 begin
  PGMbaseinfo:=false;
  if length(auxstr)>0 then
   if auxstr[1]<>'#' then 
    PGMbaseinfo:=true;
 end;

procedure FujiDarkAdd;
var a,b,c: real;
 begin
  for j:= 1 to 4 do
   begin {all according to darkframes for Javor, 2006}
    case j of
    1:begin
a              := 0.820899  ;  {+/- 0.004789     (0.5834%)}
b              := -0.00952671; {+/- 0.0001764    (1.851%)}
c              := 2.49875e-05 ;{+/- 1.558e-06    (6.235%)}
      end;
    2:begin
a              := 0.805557; {+/- 0.004196     (0.5209%)}
b              := -0.0106941; {+/- 0.0001654    (1.546%)}
c              := 3.61991e-05 {+/- 1.562e-06    (4.314%)}
      end;  
    3:begin
a              := 0.809451; {+/- 0.005909     (0.73%)}
b              := -0.0105082; {+/- 0.0002301    (2.19%)}
c              := 3.4366e-05  {+/- 2.149e-06    (6.254%)}
      end;  
    4:begin
a              := 0.809554;   {      +/- 0.0047       (0.5806%)}
b              := -0.00990897; {     +/- 0.0001772    (1.789%)}
c              := 2.91425e-05  {    +/- 1.603e-06    (5.501%)}

      end;  
    end;     
    for i:= 0 to 80 do
     begin 
      FujiAdd[j,i]:= round(0.01*(i*i*(a + i*(b + c*i))));
     end;
   end;    
 end; 


begin {of Main Programme}


if paramcount<1 then help
else for j:= 1 to paramcount do
 begin
  Par:=paramstr(j);
  CommandLine:=CommandLine+' '+Par;
  ParOrig:=Par;
  if ParFlag<>' ' then
   begin  {just some parameters are written to accept a blank before them}
    case ParFlag of
    'B': begin
          k:=ItemCountD(':',Par);
          if k>0 then LinMin:=I_S(ItemStrD(':',1,Par));
          if k>1 then LinMax:=I_S(ItemStrD(':',2,Par));
         end;
    'C': if Par='fuji' then fuji:=true else
	 if Par='fuji-' then begin fuji:=true; FujiAddInt:=false; end else
	 if Par='YCGM' then YCGM:=true else
         for k:=1 to 4 do
	  cam[k]:=I_S(copy(Par,k,1)); 
    'D': begin
          k:=ItemCountD(':',Par);
          if k>0 then 
            DarkFrame:=ItemStrD(':',1,Par);
          if k>1 then ScaleDark:=R_S(ItemStrD(':',2,Par))
	 end; 
    'E': EpsFile:=Par;
    'F': for k:=1 to length(par) do
	   case Par[k] of
	    'A': begin Medians:=false; Luminance:=true; end;
	    'T': begin Luminance:=false; LFdensity:=true; Medians:=false; end;
	    'I': begin Luminance:=false; LFdensity:=false; Medians:=false; end;
	    'M': Medians:=true;
	    'L': Luminance:=true;
	   end;     
    'I': InfoFile:=Par;
    'K': ColourImage:=Par;
    'L': minL:=R_S(Par);
    'N': LogImage:=Par;
    'O': begin
	  val(Par,auxword,auxint);
	  if auxint=0 then
           Ovlim:=auxword
          else
           OffsetFrame:=Par
	 end;   
    'U': maxL:=R_S(Par);
    'P': begin
          k:=ItemCountD(':',Par);
          if k>0 then 
            shrB:=I_S(ItemStrD(':',1,Par));
          if k>1 then ColourScale:=I_S(ItemStrD(':',2,Par))
	 end;    
    'S': begin
          Par:=copy(Par,2,length(par)-1);
          k:=ItemCountD(':',Par);
          if Par[1]='M' then 
	   begin
            Par:=copy(Par,2,length(par)-1);
            k:=ItemCountD(':',Par);
	    Smooth:=true; 
            if k>0 then 
	     begin
 	      smoothV:=I_S(ItemStrD(':',1,Par));
              if k>1 then smoothL:=I_S(ItemStrD(':',2,Par));
              if smoothL>smoothLmax then smoothL:=smoothLmax;
	     end
	   end
          else 
	   if Par[1]='-' then Smooth:=false
	   else 
           if k>0 then 
	    begin
	     SideX:=I_S(ItemStrD(':',1,Par));
             if k>1 then SideY:=I_S(ItemStrD(':',2,Par))
	     else SideY:=SideX;
	    end;
	 end; 
    'T': toCdM2:=R_S(Par);
    'W': CCDw:=R_S(Par);
	  
    end;
    ParFlag:=' ';    
   end
  else
   begin 
  Par:=__cvtstr(Par,_To_UpCase_Str);
 if {(Par[1]='/') or} (Par[1]='-') then
  begin
   Par:=copy(Par,2,length(par)-1);
   ParOrig1:=copy(ParOrig,2,length(ParOrig)-1);
  end 
 else 
   Par:='@'+ParOrig;  {should be the name of MainFrame, auxiliary @ is added}
  case Par[1] of
   '?','-','H': Help; {- added to respect unix --help even without the help}
   'A': NonCalibrated:=true; {for uncalibrated arbitrary luminance scale}
   'B': if length(par)=1 then ParFlag:='B' else
	begin
         Par:=copy(Par,2,length(par)-1);
	 k:=ItemCountD(':',Par);
	 if not (Par[1]='L') then 
	  begin 
           if k>0 then LinMin:=I_S(ItemStrD(':',1,Par));
           if k>1 then LinMax:=I_S(ItemStrD(':',2,Par));
	  end
	 else   
	  begin 
           Par:=copy(Par,2,length(par)-1);
           if k>0 then BaseLumNew:=R_S(ItemStrD(':',1,Par));
           if k>1 then StepsTo10:=I_S(ItemStrD(':',2,Par));
	   BaseLum:=BaseLumNew;
	   if (BaseLum=0) or (StepsTo10=0) then
	    begin writeln('-bL parameter is wrong'); exit; end
	   else ScaleChanged:=true;     
	  end
	end;
   'C': if length(par)=1 then ParFlag:='C' else
          if Par='CFUJI' then fuji:=true
  	  else if Par='CFUJI-' then begin fuji:=true; FujiAddInt:=false; end
	  else if Par='CYCGM' then YCGM:=true 
	  else    for k:=1 to 4 do
	  cam[k]:=I_S(copy(Par,k+1,1));
 {file names are upcased this way.... not very good}
   'D': if length(par)=1 then ParFlag:='D' else
         begin
	   darkConst:=I_S(copy(Par,2,length(par)-1));
	 end; 
   'E': if length(par)=1 then ParFlag:='E' else
        EpsFile:=copy(ParOrig1,2,length(par)-1);
   'F': if length(par)=1 then ParFlag:='F' else
         if Par[2]='C' then
	  begin
	   Par:=copy(Par,3,length(par)-2);
  	   ConvertFocus:=R_S(ItemStrD(':',1,Par));
	   k:=ItemCountD(':',Par);
	   if k>1 then if ItemStrD(':',2,Par)='N' then NoFlatFielding:=true;
	  end 
	 else
          for k:=2 to length(par) do
	   case Par[k] of
	    'A': begin Medians:=false; Luminance:=true; end;
	    'T': begin Luminance:=false; LFdensity:=true; Medians:=false; end;
	    'I': begin Luminance:=false; LFdensity:=false; Medians:=false; end;
	    'M': Medians:=true;
	    'L': Luminance:=true;
	    'F': Faintnesses:=true;
	   end;     
   'G': begin 
         if length(par)>1 then
	  if Par[2]='I' then
	   begin
            if length(par)>2 then
	     begin
	      Par:=copy(Par,3,length(par)-2);
  	      k:=ItemCountD(':',Par);
	      GrayImage:=ItemStrD(':',1,copy(ParOrig1,3,length(ParOrig1)-2));
	      if k>1 then
	       BlackLevel:=I_S(ItemStrD(':',2,Par));
	     end; 
	    MakeGrayImage:=true;
	   end 
	  else      
	  begin
	   SumGlare:=true;
           Par:=copy(Par,2,length(par)-1);
	   k:=ItemCountD(':',Par);
           if k>0 then 
	    begin CentreSee:=false; SeePX:=I_S(ItemStrD(':',1,Par)); end;
           if k>1 then 
	    begin CentreSee:=false; SeePY:=I_S(ItemStrD(':',2,Par)); end;
	  end
	 else
          SumGlare:=true;
	end;
   'I': if length(par)=1 then ParFlag:='I' else
        InfoFile:=copy(ParOrig1,2,length(par)-1);
   'J': begin {jpeg_compare}
         Par:=copy(ParOrig1,2,length(par)-1);
	 k:=ItemCountD(':',Par);
	 if k>1 then
          begin 
	   ppmFrame:=ItemStrD(':',1,Par);
	   OutJpF:=ItemStrD(':',2,Par);
           if k>2 then
	    begin
	     DlinUpSkip:=I_S(ItemStrD(':',3,Par));
	     if k>3 then 
   	      DcolLeftSkip:=I_S(ItemStrD(':',4,Par));
            end;
	   jpeg_compare:=true;      
	  end
	 end;      
    'K': if length(par)=1 then ParFlag:='K' else
        ColourImage:=copy(ParOrig1,2,length(par)-1);
    'L': if length(par)=1 then ParFlag:='L' else
	begin
         Par:=copy(Par,2,length(par)-1);
	 case Par[1] of
	  'S' : EpsLumScale:=true;
	  'N' : EpsLumScale:=false;
	  'M' : SubMed:=true;
	  else minL:=R_S(Par);
	 end; 
	end;
   'M': begin {multipliers}
         Par:=copy(Par,2,length(par)-1);
	 k:=ItemCountD(':',Par);
          if Par[1]='R' then 
	   begin 
            Par:=copy(Par,2,length(par)-1);
            k:=ItemCountD(':',Par);
            if k>0 then
	     if k=3 then 
	      begin 
              for i:=1 to k do
	       begin
	        auxreal:=R_S(ItemStrD(':',i,Par));        
                case i of
	         1: R2R:=auxreal;
	    	 2: G2G:=auxreal; 
		 3: B2B:=auxreal;
	        end
	       end;
	      LumRSet:=true;
	      end 
	     else if k=4 then
	      begin
              for i:=1 to k do
	       begin
	        auxreal:=R_S(ItemStrD(':',i,Par));        
                case i of
	         1: Y2Y:=auxreal;
	    	 2: C2C:=auxreal; 
		 3: Gy2Gy:=auxreal;
		 4: M2M:=auxreal;
	        end
	       end;
	      LumRSet:=true;
	     end 
	   end
          else if Par[1]='L' then 
	   begin 
            Par:=copy(Par,2,length(par)-1);
            k:=ItemCountD(':',Par);
            if k>0 then
	     if k=3 then
	      begin 
              for i:=1 to k do
	       begin
	        auxreal:=R_S(ItemStrD(':',i,Par));        
                case i of
	         1: Rm:=auxreal;
	    	 2: Gm:=auxreal; 
		 3: Bm:=auxreal;
	        end
	       end;
	      LumLSet:=true;
	      end 
	     else if k=4 then
	      begin
              for i:=1 to k do
	       begin
	        auxreal:=R_S(ItemStrD(':',i,Par));        
                case i of
	         1: Ym:=auxreal;
	    	 2: Cm:=auxreal; 
		 3: GYm:=auxreal;
		 4: Mm:=auxreal;
	        end
	       end;
	      LumLSet:=true;
	      end 
	   end
          else if Par[1]='M' then 
	   begin 
            Par:=copy(Par,2,length(par)-1);
            k:=ItemCountD(':',Par);
	    TwoColour:=true;
            if k>0 then
	     if k=3 then
	      begin
              for i:=1 to k do
	       begin
	        auxreal:=R_S(ItemStrD(':',i,Par));        
                case i of
	         1: Rm2:=auxreal;
	    	 2: Gm2:=auxreal; 
		 3: Bm2:=auxreal;
	        end
	       end;
	      end 
	     else if k=4 then
	      begin
              for i:=1 to k do
	       begin
	        auxreal:=R_S(ItemStrD(':',i,Par));        
                case i of
	         1: Ym2:=auxreal;
	    	 2: Cm2:=auxreal; 
		 3: GYm2:=auxreal;
		 4: Mm2:=auxreal;
	        end
	       end;
	      end
	   end
	  else
	   begin 
            for i:=1 to k do 
             LumM[i]:=R_S(ItemStrD(':',i,Par));
            LumMSet:=true;
	   end; 
	end;
   'N': if length(par)=1 then ParFlag:='N' else
         begin
          if (length(par)=2) then 
  	   case Par[2] of
	    'I' : nondark:=false;
	    'H' : PrintHistogram:=false;
	    'N' : colourNPSscale:=true;
	    'P' : PrintAllPercentils:=false;
	    'R' : AppResults:=false;
	    'T' : DoPrintTiles:=false;
	    'L' : EpsFileLines := false;
	    'C' : EpsTileNumbers := false;
	    'M' : EpsTileMedians := false;
	   else    
            LogImage:=copy(ParOrig1,2,length(par)-1);
	   end
	  else 
           LogImage:=copy(ParOrig1,2,length(par)-1);
         end;
   'O': if length(par)=1 then ParFlag:='O' else
         begin
	  val(copy(Par,2,length(par)-1),auxword,auxint);
	  if auxint=0 then
           Ovlim:=auxword
          else if ItemCountD(':',Par)=3 then
	   begin
	    Par:=copy(Par,2,length(par)-1);
	    NoOverColour:=false;
	    for k:=1 to 3 do
	     begin
   	      auxint:=I_S(ItemStrD(':',k,Par));
	                              {1 stood here before v.1.30...}      
	      if (auxint>-1) and (auxint<256) 
	       then OverColour[k]:=auxint
	       else NoOverColour:=true;
	     end  
	   end
	  else 
           OffsetFrame:=copy(ParOrig1,2,length(par)-1);
	end;   
   'P': if length(par)=1 then ParFlag:='P' else
         begin
          Par:=copy(Par,2,length(par)-1);
          k:=ItemCountD(':',Par);
          if k>0 then 
            shrB:=I_S(ItemStrD(':',1,Par));
          if k>1 then ColourScale:=I_S(ItemStrD(':',2,Par))
	 end;    
   'R': if length(par)>1 then 
         begin
	  Par:=copy(ParOrig1,2,length(ParOrig1)-1);
	  if Par[1]=':' then 
	   begin
     	    Par:=copy(Par,2,length(Par)-1);
	    F100:=I_S(ItemStrD(':',1,Par));
	    Par:=copy(Par,pos(':',Par)+1,length(par)-pos(':',par)); 
	   end; {of processing a radius unit}    
	  k:=ItemCountD(':',Par);
	  if k=2 then
	   begin
           EkvidistImageName:=ItemStrD(':',1,Par); 
	   EMaxLuminance:=R_S(ItemStrD(':',2,Par));
	   if EMaxLuminance>0 then
	    begin
	     EkvidistImage:=true;
	     EMaxLuminanceLn:=ln(EMaxLuminance);
	    end 
	   end
	  else
	   begin {k=1 , 3 or 4 :}
           OutRaF:=ItemStrD(':',1,Par); radial:=true;
	   if k=3 then 
            begin
             AzMin:=R_S(ItemStrD(':',2,Par)); 
             if AzMin<0 then AzMin:=AzMin+360; 
             AzMax:=R_S(ItemStrD(':',3,Par)); 
             if AzMax<0 then AzMax:=AzMax+360; 
	     Segment2pi:= AzMin>AzMax;
   	     AzMin:=deg_to_rad(AzMin);
   	     AzMax:=deg_to_rad(AzMax);
	     Segment:=true;
	    end
	   else if k=4 then 
            begin
             CentralAz:=deg_to_rad(R_S(ItemStrD(':',2,Par))); 
   	     HeiMinRad:=deg_to_rad(R_S(ItemStrD(':',3,Par)));
   	     HeiMaxRad:=deg_to_rad(R_S(ItemStrD(':',4,Par)));
	     Strip:=true;
	    end
	   end    
	 end
        else NonLinear:=true; {an option for computing radiances from DMSP data}
   'S': if length(par)=1 then ParFlag:='S' else
         begin
          Par:=copy(Par,2,length(par)-1);
          k:=ItemCountD(':',Par);
          if Par[1]='M' then 
	   begin 
            Par:=copy(Par,2,length(par)-1);
            k:=ItemCountD(':',Par);
	    Smooth:=true; 
            if k>0 then 
	     begin
 	      smoothV:=I_S(ItemStrD(':',1,Par));
              if k>1 then smoothL:=I_S(ItemStrD(':',2,Par))
	     end
	   end
          else 
	   if Par[1]='-' then Smooth:=false
	   else 
            if k>0 then 
	     begin
 	      SideX:=I_S(ItemStrD(':',1,Par));
              if k>1 then SideY:=I_S(ItemStrD(':',2,Par))
	      else SideY:=SideX;
	     end;
	 end; 
   'T': if length(par)=1 then ParFlag:='T' else
        if par[2]='I' then 
	 begin
	  Par:=copy(Par,3,length(par)-2);
          k:=ItemCountD(':',Par);
          if k>0 then 
	   begin
	    TileMin:=I_S(ItemStrD(':',1,Par));
            if k>1 then TileMax:=I_S(ItemStrD(':',2,Par))
	    else TileMax:=TileMin;
	   end;
	 end 
        else
        toCdM2:=R_S(copy(Par,2,length(par)-1));
   'U': if length(par)=1 then ParFlag:='U' else
        begin
         Par:=copy(Par,2,length(par)-1);
         maxL:=R_S(Par);
	end;
   'V': if length(par)>1 then begin
           OutSpF:=copy(ParOrig1,2,length(ParOrig1)); spectrum:=true; end;
   'W': if length(par)=1 then ParFlag:='W' else
         begin
          val(copy(Par,2,length(par)-1),auxreal,auxint);
	  if auxint=0 then
           CCDw:=R_S(copy(Par,2,length(Par)-1))
	  else if Par[2]='H' then OverwHead:=true;
	 end;  
   '@': MainFrame:=ParOrig;
  end; {of case}
   end; {of ParFlag<>' '}
 end; {of for}

{writeln(cam[1],cam[2],cam[3],cam[4]);}
 if (SideX<2) or (SideY<2) then 
     begin   
      writeln(
      'Please, choose a larger tile size');
      halt;
     end;

 if (smoothV<2) or (smoothL<2) then 
     begin   
      writeln(
      'Please, choose larger parameters for smoothing than 1');
      halt;
     end;


 if fuji then fuji2:=2 else fuji2:=1; {such a factor could is used 
                        just in the smooth part of makelogimage, 
			but may be used
                        elsewhere as well, 
			instead of repeated testing if fuji}

 if fuji and FujiAddInt then FujiDarkAdd;

 {zeroing the sums:}
 fillchar(his,4*4*(trueov+1),0);
 fillchar(hisd,4*4*(trueov+1),0);
 fillchar(hist,4*4*(trueov+1)*(tilenC+1),0);
 fillchar(sumLt,4*4*(tilenC+1),0);
 fillchar(rlcount,191*2,0);
 for j:=0 to RMcrad do begin rlsum[j]:=0; rlsumQ[j]:=0; end;
 if jpeg_compare then
    begin
     fillchar(jp_count,4*4*16384,0);
     for j:=1 to 4 do 
      for jw:=0 to 16383 do
       for k:=1 to 3 do jp_sum[j,jw,k]:=0;
    end; 

 for tile:=0 to tilen do
  begin
    for j:=1 to 4 do 
        zerosums;      
    nsum[5][tile]:=0;	
  end;


 if EkvidistImage then
  begin
   for Ex:=0 to EkvXmax do for Ey:=0 to 1899 do
    EkvidistImageVal[Ex,Ey]:=0;
   fillchar(EkvidistImageCount,(EkvXmax+1)*1900,0);    
  end;
 
 if LumMset then
  if YCGM then
   begin
    Ym:=LumM[1]; Cm:=LumM[2]; GYm:=LumM[3]; Mm:=LumM[4];
    Y2Y:=1; C2C:=1; Gy2Gy:=1; M2M:=1;
   end  
  else 
   begin
    Rm:=LumM[1]; Gm:=LumM[2]; Bm:=LumM[3];
    R2R:=1; B2B:=1;
   end
 else if fuji then 
  begin
   if not LumRset then  begin 
    R2R:=R2Rs5000; 
    B2B:=B2Bs5000;
    end;  
   if not LumLset then begin
    Rm:=RmCfuji; Gm:=GmCfuji; Bm:=BmCfuji;
    end;    
  end;  

 if YCGM then
  begin lcc[cam[1]]:=Ym>0; lcc[cam[2]]:=Cm>0; 
        lcc[cam[3]]:=GYm>0; lcc[cam[4]]:=Mm>0 end
 else
  begin lcc[cam[1]]:=Rm>0; lcc[cam[2]]:=Gm>0; 
        lcc[cam[3]]:=Gm>0; lcc[cam[4]]:=Bm>0 end;
 
 if YCGM then
  begin camM[1]:=Y2Y; camM[2]:=C2C; camM[3]:=Gy2Gy; camM[4]:=M2M; end
 else
  begin camM[1]:=R2R; camM[2]:=G2G; camM[3]:=G2G; camM[4]:=B2B; end;
   
 spLL:=(tilemax-tilemin+1)*SideX;

 mat(Ma_Ah_to_td,2,-pi/2{Pole_rot}); 
 {for transformation to FromMidColurAz, FromMidHei}

 FileMode:=0; {will open the files by reset as Read Only}


if jpeg_compare then
 begin
  assign(fj,ppmFrame);

  FSplit(ppmFrame,FDir,FName,FExt);
  if FExt='.ppm' then
   begin
    BitmapStartJ:=0;   {seeking the end of heading}
 {$I-}
    assign(f1t,ppmFrame);
    reset(f1t);
    if ioresult<>0 then
     begin writeln('The jpg->PPM image not found.'); close(f1t); exit; end;
    {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}

    readln(f1t,auxstr); 
    if not (auxstr='P6') then 
     begin writeln('not a 8-bit PPM'); close(f1t); exit; end
    else   
     inc(BitmapStartJ,length(auxstr) + 1{for unix files}); 


   repeat readln(f1t,auxstr);
    inc(BitmapStartJ,length(auxstr) + 1{for unix files}); 
   linlJ:=I_S(ItemStr(1,auxstr));
   linesJ:=I_S(ItemStr(2,auxstr)) div 2;
   until PGMbaseinfo;

    repeat readln(f1t,auxstr);
     inc(BitmapStartJ,length(auxstr) + 1{for unix files});
    until PGMbaseinfo;

    linlJh :=  linlJ div 2 - 1 ; 

    close(f1t); 
    reset(fj,1)
   end
  else jpeg_compare:=false;       
 end; {of if jpeg_compare then}

 
 assign(f,MainFrame);

 FSplit(MainFrame,FDir,FName,FExt);
 ImName:=FName;

 if FExt='.pgm' then
  begin
   BitmapStart:=0;
 {$I-}
   assign(f1t,MainFrame);
   reset(f1t);
   if ioresult<>0 then
     begin writeln('The Main Frame not found.'); close(f1t); exit; end;
   {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}

   readln(f1t,auxstr); 
   if not (auxstr='P5') then 
    begin writeln('not a 16-bit PGM'); close(f1t); exit; end
   else   
    inc(BitmapStart,length(auxstr) + 1{for unix files}); 


   repeat readln(f1t,auxstr);
    inc(BitmapStart,length(auxstr) + 1{for unix files}); 
   linl:=I_S(ItemStr(1,auxstr));
   lines:=I_S(ItemStr(2,auxstr)) div 2;
   until PGMbaseinfo;


   repeat readln(f1t,auxstr);
    inc(BitmapStart,length(auxstr) + 1{for unix files});
    if pos(' = black',auxstr)>0 then  
     begin
      DarkConst:=I_S(ItemStr(2,auxstr)) shr shrB; 
      {needing a special format 
      # <black> = black }
     end;
   until PGMbaseinfo;

{writeln(auxstr);}
   if not (LI_S(auxstr)>255) then
    begin bytesPP:=1; startline:=0; DarkStrip:=false; end;
   if LI_S(auxstr)=65535 then
    begin startline:=0; DarkStrip:=false; end; 
   {as DarkStrip files, just those with 4095 upper limit 
    and similar are concerned, as for D60 special format}
  
   close(f1t);

{ startline = 12; for EOS D60}
   lines := lines - (StartLine div 2);
   tilerm := lines div sideY + 1;
   linlh :=  linl div 2 - 1 ; 

{ Fuji S5000 values, for some wide-angle setting:
Resolution   : 2816 x 2120
Flash used   : No
Focal length :  7.5mm  (35mm equivalent: 23mm)
CCD width    : 11.71mm
}

{writeln('lines ',lines,
' tilerm ',tilerm,
' linl ',linl,
' linlh ',linlh,
' tilen ',tilen,
' side ', side);
}

  reset(f,1);
  end
 else        
  reset(f,linl*bytesPP); 
  {the second case is for reading the data from the output of ``decompress'', 
   a graymap with no heading}

 tilen := (linlh+1) div sideX; 
 if tilen>tilenc then
    begin 
     writeln(
      'Please, choose a larger tile size, to have less than 100 tiles a row');
     halt;
    end;       
 if linlh>linlhC then
    begin 
     writeln(
      'Sorry, maximum line length is linlhC*2',linlhC*2:6,
      ' change this constant in source code if more is needed.');
     halt;
    end;       
 if (linlh+1) mod sideX = 0 then dec(tilen); 
 if LinMax=0 then LinMax:=lines;

if DarkFrame<>'' then
 begin
  assign(fd,DarkFrame);

  FSplit(DarkFrame,FDir,FName,FExt);

  if FExt='.pgm' then
   begin
    BitmapStartD:=0;   {seeking the end of heading}
 {$I-}
    assign(f1t,DarkFrame);
    reset(f1t);
    if ioresult<>0 then
     begin writeln('The Dark Frame not found.'); close(f1t); exit; end;
    {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}

    readln(f1t,auxstr); 
    if not (auxstr='P5') then 
     begin writeln('not a 16-bit PGM'); close(f1t); exit; end
    else   
     inc(BitmapStartD,length(auxstr) + 1{for unix files}); 


    repeat readln(f1t,auxstr);
     inc(BitmapStartD,length(auxstr) + 1{for unix files}); 
    until PGMbaseinfo;

    repeat readln(f1t,auxstr);
     inc(BitmapStartD,length(auxstr) + 1{for unix files});
    until PGMbaseinfo;

    close(f1t); 
    reset(fd,1)
   end
  else        
   reset(fd,linl*bytesPP); 
   {the second case is for reading the data from the output of ``decompress'', 
   a graymap with no heading}
  SubDF:=true;  
 end {of if DarkFrame<>'' then}
else
 DarkDF:=DarkConst; 

if OffsetFrame<>'' then
 begin
  assign(fo,OffsetFrame);

  FSplit(OffsetFrame,FDir,FName,FExt);

  if FExt='.pgm' then
   begin
    BitmapStartO:=0;   {seeking the end of heading}
 {$I-}
    assign(f1t,OffsetFrame);
    reset(f1t);
    if ioresult<>0 then
     begin writeln('The Offset Frame not found.'); close(f1t); exit; end;
    {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}

    readln(f1t,auxstr); 
    if not (auxstr='P5') then 
     begin writeln('not a 16-bit PGM'); close(f1t); exit; end
    else   
     inc(BitmapStartO,length(auxstr) + 1{for unix files}); 


    repeat readln(f1t,auxstr);
     inc(BitmapStartO,length(auxstr) + 1{for unix files}); 
    until PGMbaseinfo;

    repeat readln(f1t,auxstr);
     inc(BitmapStartO,length(auxstr) + 1{for unix files});
    until PGMbaseinfo;

    close(f1t); 
    reset(fo,1)
   end
  else        
   reset(fo,linl*bytesPP); 
   {the second case is for reading the data from the output of ``decompress'', 
   a graymap with no heading}
  SubOffset:=true;  
 end; {of if OffsetFrame<>'' then}


 writeln(cl,
'Results of "raw2lum" (version ', version,') with parameters:',cl,
' ',CommandLine);

 
if InfoFile<>'' then 
 begin
 {$I-}
  assign(fdesc,InfoFile);
  reset(fdesc);
  if ioresult<>0 then
   begin writeln('The Info File not found.'); close(fdesc); exit; end;
   {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}
  repeat 
   readln(fdesc,tline);
   tline13:=copy(tline,1,13);
   tlineC:=ItemStrD(':',1,tline);
   tlineC:=RTrim(tlineC);
   if (tline13 =  
    'Exposure time') 
    or (tlineC = 'Shutter')
    or (tlineC = 'Exposure Time')
     then 
     begin
      if ItemCountD('(',tline)=2 then
       begin
        auxstr:=ItemStrD('(',2,tline);
        auxstr:=ItemStrD(')',1,auxstr);
        auxstr:=ItemStrD('/',2,auxstr);
	exp_frac:=I_S(auxstr);
	if exp_frac=0 then exp_length:=0 else exp_length:=1.0/exp_frac; 
       end	
      else
      if ItemCountD('/',tline)=2 then {dcraw output}
       begin
        auxstr:=ItemStrD('/',2,tline);
        auxstr:=ItemStrD(' ',1,auxstr);
	exp_fracR:=R_S(auxstr);
	if exp_fracR=0 then exp_length:=0 else exp_length:=1.0/exp_fracR; 
       end
      else
       begin
        auxstr:=ItemStrD(':',2,tline);
        auxstr:=ItemStrD(' ',1,auxstr);
	exp_length:=R_S(auxstr);
       end;            	
      writeln('# ',tline); 
     end
   else 
  if (tline13 =  
    'Aperture     ')
  or (tlineC = 'Aperture')
  or (tlineC = 'F Number')
    then 
     begin
     if ItemCountD('/',tline)=2 then
       begin
        auxstr:=ItemStrD('/',2,tline);
	foc_ratio:=R_S(auxstr);
       end
     else              	
       begin
        auxstr:=ItemStrD(':',2,tline);
	foc_ratio:=R_S(auxstr);
       end;
      writeln('# ',tline); 
     end
  else
  if (tline13 =  
    'ISO equiv.   ')
  or (tlineC =  
    'ISO speed')
  or (tlineC =  
    'ISO')
     then 
     begin
      if ItemCountD(':',tline)=2 then
       begin
        auxstr:=ItemStrD(':',2,tline);
	ISO :=I_S(auxstr);
       end;            	
      writeln('# ',tline); 
     end
  else 
  if (tline13 =  
    'Date/Time    ')
   then
     begin
      writeln('# ',tline); 
      ImDate:=ItemStr(3,tline);
      ImTime:=ItemStr(4,tline);
     end
  else
  if (tlineC = 'Date/Time Original')
   then
     begin
      writeln('# ',tline); 
      ImDate:=ItemStr(4,tline);
      ImTime:=ItemStr(5,tline);
     end
  else
  if (tlineC = 'Timestamp')
   then
     begin
      writeln('# ',tline); 
      ImDate:=ItemStr(3,tline)+' '+ItemStr(4,tline)+' '+ItemStr(6,tline);
      ImTime:=ItemStr(5,tline);
     end
  else
  if (tline13 =  
    'Focal length ')
  or (tlineC =  
    'Focal Length')
  or (tlineC =  
    'Focal length')
     then 
     begin
      writeln('# ',tline); 
        auxstr:=ItemStrD(':',2,tline);
        auxstr:=ItemStrD('m',1,auxstr);
        auxstr:=ItemStrD(' ',1,auxstr);
	TrueFocalLength:=R_S(auxstr);
     end
  else     
  if tline13 =  
    'Resolution   ' then 
     begin
      if fuji then
       writeln('# ',tline, ' in jpeg (',linl,'x',lines,' in ',MainFrame,')')
      else 
       writeln('# ',tline, ' in jpeg (',linl,'x',lines*2,' in ',MainFrame,')')
     end
  else     
  if (tline13 =  
    'CCD width    ')
  or (tlineC =
    'Focal Plane X Size') 
   then 
     begin
      write('# ',tline); 
      if CCDw>0 then 
       write(' (in jpg, but ', CCDw:5:2,' assumed further)');
      writeln; 
      auxstr:=ItemStrD(':',2,tline);
      auxstr:=ItemStrD('m',1,auxstr);
      CCDwidth:=R_S(auxstr);
     end;
       
            
  until eof(fdesc);
  exposure_known:= (exp_length>0) and (foc_ratio>0) and (ISO>0);
  if exposure_known then
   exposure:=ISO*exp_length/sqr(foc_ratio);
  tolumflux:=1/exposure;
  close(fdesc);
 end;  

 if CCDw>0 then CCDwidth:=CCDw; 
  {overriding the Exif info, 
    seems to be double the true one for S5000 files 
    converted to jpeg by winsoft}

 if ConvertFocus>0 then TrueFocalLength:=TrueFocalLength*ConvertFocus; 
 
  {Nikon990 FC-E8 option, hardwired:}
 if (not NoFlatFielding) and 
    ( ((ConvertFocus>0) and (ConvertFocus<0.4)) or sigma45
  {and Fuji devignetting added:}
     or Fuji ) then FlatFielding:=True; 
 
 PixAngSizeKnown:=(TrueFocalLength>0) and (CCDwidth>0);
 if PixAngSizeKnown then
  begin
  if D60ThumbExif then 
   begin
    FourPixXS:=DoublePixSize/TrueFocalLength;
    FourPixYS:=FourPixXS;
   end    
  else if fuji then {45 degrees rotated matrix}
   begin
    FourPixXS:=CCDwidth*2 /(linl*TrueFocalLength);
    FourPixYS:=CCDwidth   /(linl*TrueFocalLength)
   end    
  else 
   begin
    FourPixXS:=CCDwidth*2 /(linl*TrueFocalLength);
    FourPixYS:=FourPixXS;
   end;
  FourPixSA:=FourPixXS*FourPixYS;
  SpaceAngle:=0{FourPixSA*lines*linl/2};
  XpToD:=FourPixXS*180/pi;
  YpToD:=FourPixYS*180/pi;
  MidPixX:=linl div 4;
  MidPixY:=lines div 2;
  if (ConvertFocus>0) 
  and (ConvertFocus<0.4) then {assuming no shift without Fish Eye convertor}
   begin {assuming Nikon990 with FC-E8 set to normal lens, the centre 
          is shifted a bit}
    MidPixX:=MidPixX - 8 {was 15 prior to Sep 19, 2005};
    MidPixY:=MidPixY + 19 {was 15 prior to Sep 20, 2005};
   end;
  if fuji then
   begin 
    MidPixX:=MidPixX + 13 {369 };
    MidPixY:=MidPixY + 70 {608 };
   end;
  if not CentreSee then
   begin
    CalcFromMid(SeePX,SeePY);
    SeePR:=FromMidRad;
    SeePAz:=FromMidAz;
   end;    
  if SeePX=0 then SeePX:=MidPixX;
  if SeePY=0 then SeePY:=MidPixY;
  end
 else FourPixSA:=1;    	    

 SumGlare:=SumGlare and PixAngSizeKnown;

 if colourNPSscale then
  begin
   stepsNm1:=NPSscaleLength-1;
   StepsTo10:=25;
   BaseLum:=0.149e-3;
  end;

 lnstep:=ln(10)/StepsTo10;
 LogBase:=ln(BaseLum);
 tolum:=tolumflux/toCdM2;
 BaseLumMin:=exp(ln(BaseLum)-lnstep/2);

{ to enable luminance computation during reading of data}
 if SubDF then 
   darkE:=darkDF
 else if DarkStrip then
   darkE:=130 {a VERY crude estimate for D60, 
               can be at least 127 to 133...}
 else    
   darkE:=DarkConst; {as taken from the heading of pgm file}
 
{ to speed up the computation:}
 R2T:=R2R*Rm*tolum;
 B2T:=B2B*Bm*tolum;
 G2T:=G2G*0.5*Gm*tolum;
 dark2:=2*darkE;
 if YCGM then 
  begin
   Y2T:=Y2Y*Ym*tolum;
   C2T:=C2C*Cm*tolum;
   G2T:=Gy2Gy*GYm*tolum;
   M2T:=M2M*Mm*tolum;
  end; 
  
 if TwoColour then
  begin
 R2T2:=R2R*Rm2*tolum;
 B2T2:=B2B*Bm2*tolum;
 G2T2:=G2G*0.5*Gm2*tolum;
 if YCGM then 
  begin
   Y2T2:=Y2Y*Ym2*tolum;
   C2T2:=C2C*Cm2*tolum;
   G2T2:=Gy2Gy*GYm2*tolum;
   M2T2:=M2M*Mm2*tolum;
  end; 
  end;
   
{writeln(SRx(2,C2T), SRx(2,Y2T2), SRx(2,C2T2), SRx(2,Y2T));  
writeln(Cm:6:2, Ym2:6:2, Cm2:6:2, Ym:6:2);  
writeln(SRx(2,tolum));  
writeln(Y2Y:6:2, C2C:6:2, Gy2Gy:6:2, M2M:6:2);  
}

 if not LumNoiseSet then 
  LumNoise:= 1*tolum; {averages below 1 are unreliable}
 
 SmoothSquare:= Smooth and SmoothSquare; 
   {becomes=Smooth, being initialised true}
  
 if LogImage<>'' then
  begin
   MakeLogImage:=true;
   assign(LogImFile,LogImage);
   rewrite(LogImFile,1);
   if fuji then
    auxstr:='P6'+#10+SI(4,linl +10  )+SI(5,lines)+#10+'255'+#10
   else
    auxstr:='P6'+#10+SI(4,linl div 2 +10 )+SI(5,lines)+#10+'255'+#10;
   BlockWrite(LogImFile,auxstr[1],length(auxstr));
  end;

 if ColourImage<>'' then
  begin
   MakeColourImage:=true;
   assign(ColImFile,ColourImage);
   rewrite(ColImFile,1);
   if fuji then
    auxstr:='P6'+#10+SI(4,linl  )+SI(5,lines)+#10+'65535'+#10
   else
    auxstr:='P6'+#10+SI(4,linl div 2 )+SI(5,lines)+#10+'65535'+#10;
   BlockWrite(ColImFile,auxstr[1],length(auxstr));
   for j:=1 to 3 do 
    begin
     R2[j]:=0; G2[j]:=0; B2[j]:=0; 
     Y2[j]:=0; C2[j]:=0; M2[j]:=0; 
    end;
   R2[1]:=R2R; G2[2]:=G2G/2; B2[3]:=B2B; 
   if YCGM then
    begin
     Y2[1]:=1{*Y2Y}*1.3;  C2[1]:=-1{*C2C}*1.3; G2[1]:=-0.25*1.3; 
       M2[1]:=1{*M2M}; 
     G2[2]:=1.5{*Gy2Gy};  
       M2[2]:=-0.75;
     Y2[3]:=-1.2{*Y2Y}; C2[3]:=1.1{*C2C};  {G2[1]:=0.25;} 
       M2[3]:=1.1{*M2M};
    end;
  end;

 if MakeGrayImage then
  begin
   assign(GrayImFile,GrayImage);
   rewrite(GrayImFile,1);
   if fuji then
    auxstr:='P5'+#10+SI(4,linl * 2  )+SI(5,lines *2)+#10+'65535'+#10
   else
    auxstr:='P5'+#10+SI(4,linl  )+SI(5,lines *2)+#10+'65535'+#10;
   BlockWrite(GrayImFile,auxstr[1],length(auxstr));
  end;

 if spectrum then
  begin
   assign(OutSp,OutSpF);
   rewrite(OutSp);
   write(OutSp,'#line');
   for i:=1 to 4 do 
    begin
     if i>1 then write(OutSp,' ');
     if YCGM then 
      write(OutSp,' ',colorY[i],' av  min   max')
     else 
      write(OutSp,' ',color[i] ,' av  min   max');
     if tilemin<tilemax then for k:=tilemin to tilemax do    
      write(OutSp,' tile ',k:2);
    end;  
   writeln(OutSp);    
  end;


 for tile:=0 to tilen do
  for j:=1 to 4 do zerosums;

if DoTiles then
 captions;     

if Fext='.pgm' then
 seek(f,BitmapStart+linl*bytesPP*startline)
else 
 seek(f,startline);

if SubDF then
if Fext='.pgm' then
 seek(fd,BitmapStartD+linl*bytesPP*startline)
else 
 seek(fd,startline);

if SubOffset then
if Fext='.pgm' then
 seek(fo,BitmapStartO+linl*bytesPP*startline)
else 
 seek(fo,startline);

if jpeg_compare then
 seek(fj,BitmapStartJ+linl*bytesPP*startline);

if fuji then {devignetting type}
begin
 if TrueFocallength<8 then FujiDevi:=1
 else if TrueFocallength>50 then FujiDevi:=3
 else FujiDevi:=2; {minimum devignetting}
end;


repeat

 if Fext='.pgm' then
  begin
   BlockRead (f,line1,linl*bytesPP);
   BlockRead (f,line2,linl*bytesPP);
  end
 else
  begin 
   BlockRead (f,line1,1);
   BlockRead (f,line2,1);
  end; 

 if SubDF then
  if Fext='.pgm' then
   begin
    BlockRead (fd,lineD1,linl*bytesPP);
    BlockRead (fd,lineD2,linl*bytesPP);
   end
  else
   begin 
    BlockRead (fd,lineD1,1);
    BlockRead (fd,lineD2,1);
   end; 

 if SubOffset then
  if Fext='.pgm' then
   begin
    BlockRead (fo,lineO1,linl*bytesPP);
    BlockRead (fo,lineO2,linl*bytesPP);
   end
  else
   begin 
    BlockRead (fo,lineO1,1);
    BlockRead (fo,lineO2,1);
   end; 
                     {first double line is skipped}   
 if jpeg_compare and (lin>DlinUpSkip-1) and (lin<=linesJ) then
   begin
    BlockRead (fj,line1J,linlJ*3);
    BlockRead (fj,line2J,linlJ*3);
   end;

 inc(lin);
 InLines:= (lin>=linmin) and (lin<=linmax); 

 for i:=0 to linlh do {processing the double line}
  begin
   tile:=i div sideX;
   twoI:=2*i;
   
   if fuji then
   begin 
    if lin mod 2 = 0 then 
     begin
     v[1]:= line1[i,2]; {R}
     v[2]:= line2[i,1]; {G}
     v[3]:= line2[i,2]; {G2}
     v[4]:= line1[i,1]; {B}
     end 
    else
     begin
     v[1]:= line1[i,1];  {R}
     v[2]:= line2[i,1]; {G}
     v[3]:= line2[i,2]; {G2}
     v[4]:= line1[i,2]; {B}
    end
   end
   
   else if bytesPP=2 then
   begin
   v[1]:= line1[i,1];  {R}
   v[2]:= line1[i,2]; {G}
   v[3]:= line2[i,1]; {G2}
   v[4]:= line2[i,2]; {B}
   end else
   begin
   v[1]:= line1B[i,1];  {R}
   v[2]:= line1B[i,2]; {G}
   v[3]:= line2B[i,1]; {G2}
   v[4]:= line2B[i,2]; {B}
   end;

   if (Fext='.pgm') and (bytesPP=2) then
    for j:=1 to 4 do 
     v[j]:=swap(v[j]) shr shrB;

   if SubDF then
   begin 
   if fuji then
   begin 
    if lin mod 2 = 0 then 
     begin
     vD[1]:= lineD1[i,2]; {R}
     vD[2]:= lineD2[i,1]; {G}
     vD[3]:= lineD2[i,2]; {G2}
     vD[4]:= lineD1[i,1]; {B}
     end 
    else
     begin
     vD[1]:= lineD1[i,1];  {R}
     vD[2]:= lineD2[i,1]; {G}
     vD[3]:= lineD2[i,2]; {G2}
     vD[4]:= lineD1[i,2]; {B}
    end
   end
   else if bytesPP=2 then
    begin     
     vD[1]:= lineD1[i,1];  {R}
     vD[2]:= lineD1[i,2]; {G}
     vD[3]:= lineD2[i,1]; {G2}
     vD[4]:= lineD2[i,2]; {B}
    end else
    begin     
     vD[1]:= lineD1B[i,1];  {R}
     vD[2]:= lineD1B[i,2]; {G}
     vD[3]:= lineD2B[i,1]; {G2}
     vD[4]:= lineD2B[i,2]; {B}
    end;

   if (Fext='.pgm') and (bytesPP=2) then
      for j:=1 to 4 do 
       vD[j]:=swap(vD[j]) shr shrB;
   end;    

   if SubOffset then
   begin 
   if fuji then
   begin 
    if lin mod 2 = 0 then 
     begin
     vO[1]:= lineO1[i,2]; {R}
     vO[2]:= lineO2[i,1]; {G}
     vO[3]:= lineO2[i,2]; {G2}
     vO[4]:= lineO1[i,1]; {B}
     end 
    else
     begin
     vO[1]:= lineO1[i,1];  {R}
     vO[2]:= lineO2[i,1]; {G}
     vO[3]:= lineO2[i,2]; {G2}
     vO[4]:= lineO1[i,2]; {B}
    end
   end
   else if bytesPP=2 then
    begin     
     vO[1]:= lineO1[i,1];  {R}
     vO[2]:= lineO1[i,2]; {G}
     vO[3]:= lineO2[i,1]; {G2}
     vO[4]:= lineO2[i,2]; {B}
    end else
    begin     
     vO[1]:= lineO1B[i,1];  {R}
     vO[2]:= lineO1B[i,2]; {G}
     vO[3]:= lineO2B[i,1]; {G2}
     vO[4]:= lineO2B[i,2]; {B}
    end;

   if (Fext='.pgm') and (bytesPP=2) then
      for j:=1 to 4 do 
       vO[j]:=swap(vO[j]) shr shrB;
   end;    

   {if (lin=1) then 
    writeln(i:3, v[1]:5, v[2]:5, v[3]:5, v[4]:5, nsum[1][tile]:5);}
   Overfull:=false; BelowMinL:=false; OverMaxL:=false;

   if jpeg_compare and (lin+1>DlinUpSkip) and (lin<=linesJ) 
   and (i+1>DcolLeftSkip) then 
    begin
     jw:=i-DcolLeftSkip;
     if jw<=linlJh then
     begin
      jp_v[1]:= line1J[jw,1]+line1J[jw,4]+line2J[jw,1]+line2J[jw,4];  {R}
      jp_v[2]:= line1J[jw,2]+line1J[jw,5]+line2J[jw,2]+line2J[jw,5]; {G}
      jp_v[3]:= line1J[jw,3]+line1J[jw,6]+line2J[jw,3]+line2J[jw,6]; {B}
      for j:=1 to 4 do
       begin
        inc(jp_count[j,v[j]]);
        for k:=1 to 3 do jp_sum[j,v[j],k]:=jp_sum[j,v[j],k]+jp_v[k];
       end; 
     end;
    end;  

   for j:=1 to 4 do 
    begin

     if lcc[j] then o[j]:=(v[j]>=ovlim); {is overfull}
 
     vRaw[j]:=v[j];  
  
     if SubDF then 
      begin
      if SubOffset then
        auxint:=v[j]-vO[j]+darkDF - round((vD[j]-vO[j])*ScaleDark)
       else    
        auxint:=v[j]+darkDF-vD[j]; 
      if auxint>0 then v[j]:=auxint else v[j]:=0;
      end; 

     if o[j] then  Overfull:=true;

      
     if v[j] < minv[j][tile] then minv[j][tile]:=v[j];
     if v[j] > maxv[j][tile] then maxv[j][tile]:=v[j];

     if spectrum then 
      if tile in [tilemin..tilemax] then
       begin {summing the line segment}
        if v[j] < minvL[j] then minvL[j]:=v[j];
        if v[j] > maxvL[j] then maxvL[j]:=v[j];
        if v[j]>0 then 
	 begin
	  sumL[j]:= sumL[j] + v[j];
	  sumLt[j][tile]:= sumLt[j][tile] + v[j];
         end;
       end;            

     if DarkStrip and (tile = 0) then 
      begin if i>0 then inc(hisd[j][v[j]]) end 
            {the first double-column is ignored}
     else 
      begin
       inc(his[j][v[j]]);
      end; 
     if DoTiles then inc(hist[j,v[j],tile]); 
{writeln(j:1,v[j]:4,tile:3,hist[j,v[j],tile]:3);}
    end; {of summing the four pixel values}
 
   TrueOverfull:=Overfull;	
   CalcFromMid(i,lin);
   if (not Overfull) then {none of the four pixels >= ovlim}
    if not NonLinear then
     begin
      if YCGM then
	 L:=  (Y2T*(v[cam[1]]-darkE) 
              +C2T*(v[cam[2]]-darkE)
	      +G2T*(v[cam[3]]-darkE)
              +M2T*(v[cam[4]]-darkE) 
 	      )
      else 
       L:=
        R2T*(v[cam[1]] - darkE)+
        G2T*(v[cam[2]]+v[cam[3]] - dark2)+
        B2T*(v[cam[4]] - darkE) ;
      if FlatFielding and (FromMidDeg<95) then
       L:=L/DeVign; 
       L2:=L;
      Overfull:=Overfull or (L<minL) or (L>maxL);
       {the above formula is evidently meant for processin a series of images
        but it spoils the meaning of Overfull}   
      BelowMinL:=(L<minL);
      OverMaxL:= (L>maxL);	 
      if Smooth then {computing an average of 4 pixels, the``4px'' value}
       begin
        AverPix[i]:=0;
        for j:=1 to 4 do
         AverPix[i]:=AverPix[i]+round(v[j] - darkE);
        AverPix[i]:=AverPix[i] div 4; 
        L_i[i]:=L;
       end;
      if TwoColour then 
      begin	
      if YCGM then
	 L2:=  (Y2T2*(v[cam[1]]-darkE) 
              +C2T2*(v[cam[2]]-darkE)
	      +G2T2*(v[cam[3]]-darkE)
              +M2T2*(v[cam[4]]-darkE) 
 	      )
      else 
       L2:=
        R2T2*(v[cam[1]] - darkE)+
        G2T2*(v[cam[2]]+v[cam[3]] - dark2)+
        B2T2*(v[cam[4]] - darkE) ;
      if FlatFielding and (FromMidDeg<95) then
       L2:=L2/DeVign;
       L_i2[i]:=L2;
      end; {of TwoColour}  
{writeln('tolum ',SRx(2,tolum), SRx(2,Y2T), ' C2T: ', SRx(2,C2T), 
 SRx(2,G2T), SRx(2,M2T) ); 
writeln('tolum ',SRx(2,tolum), SRx(2,Y2T2), ' C22: ', SRx(2,C2T2), 
 SRx(2,G2T2), SRx(2,M2T2) ); exit;
}     end {of not NonLinear}
    else {just for gray DMSP data}
     begin
      L:=0;
      for j:=1 to 4 do
       if v[j]>0 then L:=L+ exp(ln(v[j])*1.5);
      L:=L*tolum; 
     end;

   if (not Overfull) and InLines then 
    begin
      lsum:=lsum+L;
      if FromMidCos>0 then
       begin
        ilsum:=ilsum + FromMidCos*L/FromMidAreaMag;
        ilSQMsum:=ilSQMsum + FromMidSQM*L/FromMidAreaMag;
        SpaceAngle:=SpaceAngle + 1/FromMidAreaMag;
       end;
      if Radial then
       begin 
        InSegment:=false;
        if Segment then 
	  if Segment2pi then 
	   begin
  	    if FromMidAz<=AzMax then InSegment:=true;
  	    if FromMidAz>=AzMin then InSegment:=true
	   end
	  else     
	   InSegment:= (FromMidAz<=AzMax) and (FromMidAz>=AzMin)
	else 
	 if Strip then {is it between the chosen parallels and colurs?}
	  InSegment:= (FromMidColurAz<=AzMaxRad) and (FromMidColurAz>=AzMinRad)
	          and (FromMidHeight<=HeiMaxRad) and (FromMidHeight>=HeiMinRad)
	 else InSegment:=true;
	if InSegment then
	 begin 
  	  if F100>10 then j:=round(FromMidRad*F100)
	  else j:= FromMidPix div F100;
 	  rlsum[j]:= rlsum[j] + L {/FromMidAreaMag does not belong here
	                         -- and error of 1.09 version} ;
 	  rlsumQ[j]:= rlsumQ[j] + sqr(L);
 	  inc(rlcount[j]);
	 end; 
       end;
      if SumGlare then 
       if (ConvertFocus>0) or sigma45 then
       begin
        if CentreSee then
         SqAngDist:=sqr(FromMidDeg)
	else
 	 SqAngDist:=sqr(ang_distRD(SeePAz,SeePR,FromMidAz,FromMidRad));
        if SqAngDist>0.1 then
         VeiLum:=VeiLum+L/SqAngDist/FromMidAreaMag;
       end 
      else 	            
       begin {planar geometry} 
        SqAngDist:= sqr((i-SeePx)*XpToD)+sqr((lin-SeePy)*YpToD) ;
        if SqAngDist>0.1 then
         VeiLum:=VeiLum+L/SqAngDist;
       end;	 
      if MakeLogImage then 
       begin 
         if (TwoColour and ( (L2<MinL) or (L<=0) or (L2<=0) ) ) 
	 or ((not Twocolour) and (L<BaseLumMin)) then 
	  begin
          if fuji then
    	   fillchar(LogCol[twoI][1],6,0)
          else  
           fillchar(LogCol[i][1],3,0);
          {if TwoColour then L_i[i]:=0;}
	  end 
	 else
	  begin
           if TwoColour then 
	    LogLR:=(ln(L/L2)-LogBase)/lnstep
	   else
	    LogLR:=(ln(L)-LogBase)/lnstep;
           if LogLR>stepsNm1 then LogLR:=stepsNm1;
	   LogL:=round(LogLR);
           if LogLR<0 then LogLR:=0;
           if fuji then
            for j:=1 to 3 do
	     begin  
 	      if colourNPSscale then
                LogCol[twoI][j]:=NPSscale[LogL,j]
 	      else
                LogCol[twoI][j]:=
               colorLog[LogL div shadesN][j] * pow2m1[LogL mod shadesN] div 2;
              LogCol[twoI+1][j]:=LogCol[twoI][j];
	      {doubling the pixels to preserve the aspect ratio}
             end	       
	   else
            for j:=1 to 3 do  
 	      if colourNPSscale then
                LogCol[i][j]:=NPSscale[LogL,j]
 	      else
                LogCol[i][j]:=
	      colorLog[LogL div shadesN][j] * pow2m1[LogL mod shadesN] div 2;
{plotting a white circle behind 90 degrees:}	      
if (FromMidCos<0) and (FromMidCos>-0.01) then 	      
 for j:=1 to 3 do  
 LogCol[i][j]:=255;
	  end; 
       end;	 
      for j:=1 to 4 do
         if not(o[j]) then
      begin
       if (i>0) or (not DarkStrip) then 
          {the first double-column is ignored, as too white for D60} 
        begin
	 if v[j]>0 then
          if not NonLinear then
           sum[j][tile]:= sum[j][tile] + v[j]
          else
           sum[j][tile]:= sum[j][tile] + round(exp(ln(v[j])*1.5));
         if vRaw[j]>0 then inc(nsumRaw[j][tile]);
         inc(nsum[j][tile]);
        end	
      end
         else inc(osum[j][tile]);
      inc(nsum[5][tile]);	 
end
   else {is Overfull} 
    begin
     for j:=1 to 4 do
      begin
       if o[j] or (not TrueOverfull) then inc(osum[j][tile])
                  {no 4-pixel outside the -L -U interval should be
		   further n-summed to produce luminance}    
       else
       begin
       if (i>0) or (not DarkStrip) then 
          {the first double-column is ignored, as too white for D60} 
        begin
	 if v[j]>0 then
          if not NonLinear then
           sum[j][tile]:= sum[j][tile] + v[j]
          else
           sum[j][tile]:= sum[j][tile] + round(exp(ln(v[j])*1.5));
         if vRaw[j]>0 then inc(nsumRaw[j][tile]);
         inc(nsum[j][tile]);
        end	
       end
      end;
     if MakeLogImage then
      if TrueOverfull or OverMaxL then 
       if NoOverColour then 
        if fuji then
         fillchar(LogCol[twoI][1],6,255)
        else  
         fillchar(LogCol[i][1],3,255)
       else
        for j:=1 to 3 do
         if fuji then 
	  begin
           LogCol[twoI][j]:=OverColour[j]; 
	   LogCol[twoI+1][j]:=OverColour[j]  
          end
         else  
           LogCol[i][j]:=OverColour[j]
       	 
      else {BelowMaxL}
       if fuji then
        fillchar(LogCol[twoI][1],6,0)
       else  
        fillchar(LogCol[i][1],3,0);
     AverPix[i]:=-16000;
    end;

   if MakeColourImage then 
    begin 
        for j:=1 to 3 do  
	 begin
          if YCGM then
           auxreal:= 
	     Y2[j]*(v[cam[1]]-darkE) 
    	    +C2[j]*(v[cam[2]]-darkE)
	    +G2[j]*(v[cam[3]]-darkE)
            +M2[j]*(v[cam[4]]-darkE) 
  	  else
           auxreal:= 
            R2[j]*(v[cam[1]] - darkE)+
            G2[j]*(v[cam[2]]+v[cam[3]] - dark2)+
            B2[j]*(v[cam[4]] - darkE) ;
	  if fuji then 
	   if auxreal>0 then 
	    begin 
	     ColCol[twoI][j]:=round(ColourScale*auxreal);     
	     ColCol[twoI][j]:=swap(ColCol[twoI][j]);     
	     ColCol[twoI+1][j]:=ColCol[twoI][j]
	    end
	   else begin ColCol[twoI][j]:=0; ColCol[twoI+1][j]:=0 end
	  else
	   begin
          if auxreal>0 then ColCol[i][j]:=round(ColourScale*auxreal)
	  else ColCol[i][j]:=0;
	  ColCol[i][j]:=swap(ColCol[i][j]);
	   end;
         end;
    end;	 

   if MakeGrayImage then 
    begin 
     jw:=twoI*fuji2; 
     for j:=1 to 4 do  
      begin
       jj:=fuji2*(j mod 2);
       auxreal:= BlackLevel + ColourScale * camM[cam[j]] * (v[j] - darkE);
       if auxreal>65535 then auxreal:=65535; 
       if auxreal<0 then auxreal:=0; 
       if fuji then 
	begin
         GrayCol [j div 3] [jw +2 - jj] := round(auxreal);
         GrayCol [j div 3] [jw +2 - jj] := swap( 
	 GrayCol [j div 3] [jw +2 - jj] );
         GrayCol [j div 3] [jw +3 - jj] := 
         GrayCol [j div 3] [jw +2 - jj];
	end
       else
        begin
         GrayCol [j div 3] [jw +1 - jj] := round(auxreal);
         GrayCol [j div 3] [jw +1 - jj] := swap( 
	 GrayCol [j div 3] [jw +1 - jj] );
	end;    
      end;
    end;	 
 
   if EkvidistImage and (FromMidDeg<100) then 
   if EkvidistXY then
    begin
         if TrueOverfull then L:=EMaxLuminance;
         EkvidistImageVal[Ex,Ey]:=EkvidistImageVal[Ex,Ey]+L;
         inc(EkvidistImageCount[Ex,Ey]);
	 ExO:=Ex; EyO:=Ey;
	 for j:=0 to 2 do for k:=0 to 2 do
	  begin
	   CalcFromMid(i-1+j,lin-1+k);
	   if EkvidistXY then
	    begin
	     ExD:=ExO-Ex; EyD:=EyO-Ey;
{	     if ExD>1 then ExD:=ExD div 2 + ExD mod 2
	     else if ExD<-1 then ExD:=ExD div 2 - ExD mod 2
	     else ExD:=0;
	     if EyD>1 then EyD:=EyD div 2 + EyD mod 2
	     else if ExD<-1 then EyD:=EyD div 2 - EyD mod 2
	     else EyD:=0;
  -- this left too many black pixels, so some smoothing is done instead     
}	     if abs(ExD)>0 then 
	      for jj:=0 to abs(ExD) do
	       for jw:=0 to abs(EyD) do
	        begin 
		 ij:=jj * ExD div abs(ExD);
		 if abs(EyD)>0 then ik:=jw * EyD div abs(EyD)
		 else ik:=0;
                 EkvidistImageVal[Ex+ij,Ey+ik]:=
  		  EkvidistImageVal[Ex+ij,Ey+ik]+L;
                 inc(EkvidistImageCount[Ex+ij,Ey+ik]);
	        end
	     else if abs(EyD)>0 then 		 
	       for jw:=0 to abs(EyD) do
	        begin  
		 ik:=jw * EyD div abs(EyD);
                 EkvidistImageVal[Ex,Ey+ik]:=
  		  EkvidistImageVal[Ex,Ey+ik]+L;
                 inc(EkvidistImageCount[Ex,Ey+ik]);
	        end
	    end;	
          end;		
    end;    
     
       
  end;  {of processing the double line}

if MakeLogImage then 
 begin
  {creating a colour scale at the right margin;
   unlike in pre-1.04 versions the scale rises upwards now}  
  if fuji then
   inc(twoI,2)
  else   
   twoI:=twoI div 2 + 1;

  LogL:=stepsNm1 - (((stepsNm1+1)*lin)-1) div lines;
{writeln(lin:6, LogL:4);}
  for j:=1 to 3 do
   begin 
     if colourNPSscale then
      LogCol[twoI][j]:=NPSscale[LogL,j]
     else
      LogCol[twoI][j]:=
     colorLog[LogL div shadesN][j] * pow2m1[LogL mod shadesN] div 2;
    for i:=1 to 9 do       
     LogCol[twoI+i][j]:=LogCol[twoI][j];
    if ScaleChanged then {black strip in the middle of the scale}     
     LogCol[twoI+5][j]:=0;
   end;  

  {averages for the noisy parts of the line:}
  if Smooth then 
   begin
    noiseL:=0;
    for i:= 0 to linlh do
    begin
     if (AverPix[i]<smoothV) and (AverPix[i]>-16000) then 
      inc(noiseL) else noiseL:=0; {they have to be all 4px's below threshold}
{writeln(noiseL,' ',AverPix[i],' ',smoothV,' ',smoothL);}
     if noiseL=smoothL then
      begin 
       twoI:=fuji2*i;     
       noiseL:=0; L:=0; L2:=0;
       for j:=1 to smoothL do 
        begin
         L := L + L_i [i+1-j];
         L2:=L2 + L_i2[i+1-j];
	end;
       L:=L/smoothL; L2:=L2/smoothL; 
 
       if fuji and SubDF and FujiAddInt then  
        {a simple attempt to enlarge luminaces for medians 10 to 100}
        begin
	 {using just green2 curve and assuming reddish points:}
	 auxint:=round(L/tolum);
	 if auxint > 80 then 
          L:= L + (R2T+2*G2T) * FujiAdd[3,80]
         else if auxint>0 then 
	  L:=L + (R2T+2*G2T) * FujiAdd[3,auxint];
	 if TwoColour then 
	 begin
	  auxint:=round(L2/tolum);
	  if auxint > 80 then 
           L2:= L2 + (R2T+2*G2T) * FujiAdd[3,80]
          else if auxint>0 then 
	   L2:=L2 + (R2T+2*G2T) * FujiAdd[3,auxint];
	 end; 
        end;

       if TwoColour then if (L2 > LumNoise) and (L > LumNoise) 
        then L:=L/L2 else L:=0;
	
         if L<BaseLumMin then {filling the segment with grey}
    	   fillchar(LogCol[twoI-(smoothL-1)*fuji2][1],3*fuji2*smoothL,100)
	 else
	  begin
           LogLR:=(ln(L)-LogBase)/lnstep;
           if LogLR>stepsNm1 then LogLR:=stepsNm1;
           if LogLR<0 then LogLR:=0;
	   LogL:=round(LogLR);
           {if fuji then}
            for j:=1 to 3 do
	     begin  
 	      if colourNPSscale then
                LogColS:=NPSscale[LogL,j]
 	      else
                LogColS:=
                 colorLog[LogL div shadesN][j] * pow2m1[LogL mod shadesN] div 2;
	      for k:= 1 to fuji2*smoothL do
               {LogCol[twoI+2-k][j]:=LogColS;}
               LogCol[twoI+1-k][j]:=LogColS;
             end	       
	  end	     
      end; {of if noiseL=smoothL}
    end;  
{halt;}    
   end; {of if Smooth}
 
  if not SmoothSquare then {never...}
  if fuji then
   BlockWrite(LogImFile,LogCol,3*(linl +10 ))
  else  
   BlockWrite(LogImFile,LogCol,3*(linl div 2 +10 ))
  else {storing up to smoothL lines, ever...}
   begin 
    inc(lineL);
    for i:= 0 to (fuji2*linlh + 10) do for j:=1 to 3 do
     LogLine[lineL][i][j]:=LogCol[i][j];
    for i:= 0 to linlh do 
     begin
      AverPixLine[lineL][i]:=AverPix[i];
      L_Line[lineL][i]:= L_i[i];
      L_Line2[lineL][i]:= L_i2[i];
     end; 
    if lineL=smoothL then
     begin
      {begin of smoothing squares:}
       for iS:= 0 to linlh div smoothL - 1 do 
           {iS is number of the square, starting at zero}
        begin
	  i:=iS*smoothL;
          L:=0; L2:=0; Smoo:=true;
          for j:=1 to smoothL do for k:=1 to smoothL do
           begin
            L :=L  + L_Line[k][i+j-1];
            L2:=L2 + L_Line2[k][i+j-1];
	    Smoo:=Smoo 
	          and (AverPixLine[k,i+j-1]<smoothV) 
		  and (AverPixLine[k,i+j-1]>-16000);
	   end;
	   
	  if Smoo then
	   begin 
            L2:=L2/sqr(1.0*smoothL); L:=L/sqr(1.0*smoothL);

       if fuji and SubDF and FujiAddInt then  
        {a simple attempt to enlarge luminaces for medians 10 to 100}
        begin
	 {using just green2 curve and assuming reddish points:}
	 auxint:=round(L/tolum);
	 if auxint > 80 then 
          L:= L + (R2T+2*G2T) * FujiAdd[3,80]
         else if auxint>0 then 
	  L:=L + (R2T+2*G2T) * FujiAdd[3,auxint];
	 if TwoColour then 
	 begin
	  auxint:=round(L2/tolum);
	  if auxint > 80 then 
           L2:= L2 + (R2T+2*G2T) * FujiAdd[3,80]
          else if auxint>0 then 
	   L2:=L2 + (R2T+2*G2T) * FujiAdd[3,auxint];
	 end; 
        end;

       if TwoColour then if (L2 > LumNoise) and (L > LumNoise) 
        then L:=L/L2 else L:=0;

         if L<BaseLumMin then {filling the segment with grey}
          for k:=1 to smoothL do
    	   fillchar(LogLine[k][i*fuji2],3*fuji2*smoothL,100)
	 else
	  begin
           LogLR:=(ln(L)-LogBase)/lnstep;
           if LogLR>stepsNm1 then LogLR:=stepsNm1;
           if LogLR<0 then LogLR:=0;
	   LogL:=round(LogLR);
           {if fuji then}
            for j:=1 to 3 do
	     begin  
 	      if colourNPSscale then
                LogColS:=NPSscale[LogL,j]
 	      else
                LogColS:=
                 colorLog[LogL div shadesN][j] * pow2m1[LogL mod shadesN] div 2;
 	      for k:= 1 to fuji2*smoothL do for jj:=1 to smoothL do
               {LogCol[twoI+2-k][j]:=LogColS;}
               LogLine[jj][i*fuji2+k-1][j]:=LogColS;
             end	       
	  end	     

	  end;  {of if Smoo}    	 
        end;
      {end of smoothing squares}
      for k:= 1 to smoothL do 
       if fuji then
        BlockWrite(LogImFile,LogLine[k],3*(linl +10 ))
       else  
        BlockWrite(LogImFile,LogLine[k],3*(linl div 2 +10 ));
      lineL:=0;
{writeln;}
     end; {of if lineL=smoothL} 
   end;
      
 end; {of if MakeLogImage then}

if MakeColourImage then
 begin
  if fuji then
   BlockWrite(ColImFile,ColCol,6*(linl  ))
  else  
   BlockWrite(ColImFile,ColCol,6*(linl div 2 ));
 end; 

if MakeGrayImage then
 begin
  if fuji then
   begin
    BlockWrite(GrayImFile,GrayCol[0,0], 4*linl) ;
    BlockWrite(GrayImFile,GrayCol[1,0], 4*linl) ;
   end
  else  
   begin
    BlockWrite(GrayImFile,GrayCol[0,0], 2*linl) ;
    BlockWrite(GrayImFile,GrayCol[1,0], 2*linl) ;
   end
 end; 
 

if DoTiles and (lin mod sideY = 0) then 
 begin
{ for j:=1 to 4 do writeln(his[j][0]); }
  PrintTiles
 end; 

if spectrum then 
 begin
  write(OutSp,lin:4); 
  for jj:=1 to 4 do 
   begin
    j:=cam[jj];   
    if SubDF then 
     begin
      write(OutSp, sumL[j]/SpLL - DarkDF :8:1 , minvL[j]-DarkDF:6, maxvL[j]-DarkDF:6);
      if tilemax>tilemin then for k:=tilemin to tilemax do
       write(OutSp, 1.0*sumLt[j][k]/SideX - DarkDF :8:1);
     end
    else
     begin
      write(OutSp, sumL[j]/SpLL :8:1, minvL[j]:6 , maxvL[j]:6);
      if tilemax>tilemin then for k:=tilemin to tilemax do
       write(OutSp, 1.0*sumLt[j][k]/SideX :8:1);
     end;
    sumL[j]:=0;
    minvL[j]:=trueov;
    maxvL[j]:=0;
   end;    
  writeln(OutSp); 
  fillchar(sumLt,4*4*(tilenC+1),0);
 end;

until lin=lines;

if LineL>0 then
      for k:= 1 to LineL do 
       if fuji then
        BlockWrite(LogImFile,LogLine[k],3*(linl +10 ))
       else  
        BlockWrite(LogImFile,LogLine[k],3*(linl div 2 +10 ));


close(f); 
if SubDF then close(fd); 

if MakeLogImage then close(LogImFile); 

if MakeColourImage then close(ColImFile); 

if MakeGrayImage then close(GrayImFile); 

if Spectrum then close(OutSp);

if {DoPrintTiles and} (lin mod sideY > 0)  then PrintTiles;

if EpsFile<>'' then
 begin
  if EpsLumScale then 
   begin
    if colourNPSscale then
     csingle:=lines*2/NPSscaleLength
    else
     csingle:=(lines*2/colorsN)/shadesN;
    writeln(draw,
'/rs {dup stringwidth exch neg exch rmoveto show} def',cl,
'gsave',cl,
'/Helvetica 33 selectfont',cl,
linl:5,' 12 sub ', (csingle/2):4:1,' 33 2 div sub 3 add translate');

    if colourNPSscale then
     for i:=0 to NPSscaleLength-1 do
      writeln(draw, 
       '(',SRx(2,BaseLum*exp((i)*ln(10)/StepsTo10)),') 0 ',
       csingle*(i):6:1,' m rs')
    else 
     for i:=0 to colorsN-1 do
      for j:=0 to shadesN-1 do
       writeln(draw, 
        '(',SRx(2,BaseLum*exp((i*shadesN+j)*ln(10)/StepsTo10)),') 0 ',
        csingle*(i*shadesN+j):6:1,' m rs');

   end;
  writeln(draw,cl,'showpage');
  close(draw);
 end;

if EkvidistImage then
 begin
   assign(LogImFile,EkvidistImageName);
   rewrite(LogImFile,1);
   auxstr:='P5'+#10
    +SI(4,EkvXmax+1)+SI(5,1900)+#10
    +'# 255 + 70*log(luminance / '+SRx(2,EMaxLuminance)+') coded image,'+#10
    +'# results of raw2lum '+CommandLine+#10
    +'255'+#10;
   BlockWrite(LogImFile,auxstr[1],length(auxstr));
   for Ey:=0 to 1899 do
    begin
     fillchar(EkvidistImagePix,EkvXmax+1,0);
     auxint:=0;
     for Ex:=0 to EkvXmax do 
      if (EkvidistImageCount[Ex,Ey]>0) 
      and (EkvidistImageVal[Ex,Ey]>0) then
       begin 
         auxint:= 255 + round(70 * 
          ( ln(EkvidistImageVal[Ex,Ey]/EkvidistImageCount[Ex,Ey]) -
          EMaxLuminanceLn ));
	 if auxint<0 then auxint:=0;
	 if auxint>255 then auxint:=255;
	 EkvidistImagePix[Ex]:=auxint;
       end
      {else EkvidistImagePix[Ex]:=auxint};	 
     BlockWrite(LogImFile,EkvidistImagePix,EkvXmax+1)
    end;
   close(LogImFile)    
 end;    

if Radial then {output of luminance vers. angular distance}
 begin
  assign(OutSp,OutRaF);
  rewrite(OutSp);
    if PixAngSizeKnown and (not NonCalibrated) then
     begin
      writeln(OutSp,'# ',OutRaF,' radial luminance table');
      writeln(OutSp,'# Results of raw2lum ',CommandLine,'.');
      write(OutSp,'#');
      write(OutSp,' From', SpaceAngle*FourPixSA :5:2,
       ' sr (',SRx(2,FourPixSA),' sr/4px) comes ');
      write(OutSp,
	  SRxb(2,FourPixSA*iLsum,7), ' lx');
      if SpaceAngle>3 then 	  
      writeln(OutSp,' (assumed SQM',
	  SRxb(2,FourPixSA*iLSQMsum/1.53,7), ' nt,',
  	   -2.5*ln( (FourPixSA*iLSQMsum/1.53) *
                          sqr(Pi/180/3600) / ZeroMag ) / ln10
           :6:2 , ' mag)'
	   );
     end;
  if F100>10 then      	   
  writeln(OutSp,'# angle / ',F100:3, ' / rad' )
  else
  writeln(OutSp,'# 4pix-hor-dim from centre div ',F100:2 );
  writeln(OutSp,'#     number of 4px points');
  writeln(OutSp,'#          luminance / 1 nt');
  writeln(OutSp,'#                  its relative standard deviation ');
  for j:=0 to RMcrad do
    if (rlcount[j]>1) and (rlsum[j]>0) then 
     writeln(OutSp, j:3, rlcount[j]:7,' ',
      SRxb(2,rlsum[j]/rlcount[j] , 8) ,
      SRx(2,sqrt((rlsumQ[j] - sqr(rlsum[j])/rlcount[j])
                    / (rlcount[j]-1)) 
		  / (rlsum[j]/rlcount[j]) )
	     );
  close(OutSp); 
 end;

if jpeg_compare then
 begin
  assign(OutSp,OutJpF);
  rewrite(OutSp);
  writeln(OutSp,'# raw value');
  writeln(OutSp,'#      number of incidences');
  writeln(OutSp,'#              R      G      B  jpeg average value');
  for j:=1 to 4 do
   begin
    write(OutSp,cl2,'# colour',j:3);
    if YCGM then
     writeln(OutSp,' = ',colorY[cam[j]])
    else
     writeln(OutSp,' = ',color[cam[j]]);
    for jw:=0 to 16383 do if jp_count[j,jw]>0 then
     begin
      write(OutSp,jw:4,jp_count[j,jw]:6);
      for k:=1 to 3 do
       write(OutSp,jp_sum[j,jw,k]/jp_count[j,jw]:7:1);
      writeln(OutSp);         
     end;
    end; 
  close(OutSp); 
 end; 
 
 
if SubDF or (not DarkStrip) then 
    {black for Canon could be set also by the heading of pgm}
 begin
  dark:=darkDF;
  darkFloat:=dark;
 end
else
if darkN>0 then {darkN>0 = DarkStrip} 
 begin
  darkFloat:= 1.0* dark / darkN;
  dark:=dark div darkN;
 end
else 
 begin
  writeln('Some queer situation with dark value, stopping');
  halt;   {this should never happen, but who knows with all the versions} 
 end;

for j:=1 to 4 do 
 begin
{writeln(j,' ',mint[j],' ',min);}
  if mint[j]<min then min:=mint[j];
  if maxt[j]>max then max:=maxt[j];
 end; 


for j:=1 to 4 do
 begin
  count:=sumN[j]+osumt[j];
  if DarkStrip then
   begin
    if count <> lines*(linlh+1-sideX) then writeln('# Queer count: ', count)
   end
  else 
   if count <> lines*(linlh+1) then writeln('# Queer count: ', count);
  for k:=1 to percn do
   begin
    perc[j][k]:=trunc(0.01*percv[k]*count);
   end;    
  for k:=1 to 99 do
   begin
    perc100[j][k]:=trunc(0.01*k*count);
   end;    
  for k:=100 to 108 do
   begin
    perc100[j][k]:=trunc((0.99+0.001*(k-99))*count);
   end;    
  for k:=109 to 118 do
   begin
    perc100[j][k]:=trunc((0.999+0.0001*(k-108))*count);
   end;    
 end;


if PrintHistogram then
 begin
  writeln;
  writeln('# Image histogram, lossless');
  if YCGM then
   writeln(
   '# value   Y      C      G      M   counts ') 
  else
   writeln(
   '# value   R     G1     G2      B   counts ');
 end;

for i:=min to max do
 begin
  nonzero:=false;
  for j:=1 to 4 do
   nonzero:=nonzero or (his[j][i]>0);
  if nonzero then 
  begin
   overdark:=i;
   dec(overdark,dark);
   if PrintHistogram then write(overdark:4);
   for j:=1 to 4 do
    begin
     if PrintHistogram then 
      if his[j][i]>0 then write(his[j][i]:7)
      else write('      .'); {to make histogram more readable}
     inc(dist[j], his[j][i]);
     if kf[j]<=percn then
      if dist[j]>=perc[j][kf[j]] then 
       repeat
{writeln(cl, kf[j],' ',j,' ',perc[j][kf[j]],' ',dist[j],' ',i-dark);}
        percval[j][kf[j]]:=i; 
	 {perc became the value instead of the count needed,
	  now percval is set instead}
        inc(kf[j]);
       until (dist[j]<perc[j][kf[j]]) or (kf[j]>percn);
     if k100[j]<=118 then
      if dist[j]>=perc100[j][k100[j]] then 
       repeat
{writeln(cl, k100[j],' ',j,' ',perc100[j][k100[j]],' ',dist[j],' ',i-dark);}
        percvalall[j][k100[j]]:=i; 
        inc(k100[j]);
       until (dist[j]<perc100[j][k100[j]]) or (k100[j]>118);
    end;
   if PrintHistogram then writeln;
  end;       
 end;  

for j:=1 to 4 do
 begin
  if kf[j]>1 then i:=percval[j][kf[j]-1];
    while kf[j]<=percn do {for case of max-min<percn}
     begin
      percval[j][kf[j]]:=i ;
      inc(kf[j]);
     end; 
 end;

for j:=1 to 4 do
 begin
  if k100[j]>1 then i:=percvalall[j][k100[j]-1];
    while k100[j]<=118 do {for case of max-min<118}
     begin
      percvalall[j][k100[j]]:=i ;
      inc(k100[j]);
     end; 
 end;     

if PrintHistogram 
and DarkStrip then
 begin
  writeln;
  writeln('# Dark strip histogram, lossless');
  if YCGM then
   writeln('# value  Y     C     G     M   counts')
  else
   writeln('# value  R    G1    G2     B   counts');


  for i:=darkmin to darkmax do
   begin
    nonzero:=false;
    for j:=1 to 4 do
     nonzero:=nonzero or (hisd[j][i]>0);
    if nonzero then 
     writeln(i-dark:4, hisd[1][i]:6, hisd[2][i]:6, hisd[3][i]:6, hisd[4][i]:6);
   end;
 end;

if PrintAllPercentils then
begin
writeln; 
write('# Image percentils         ');
if nondark then
 if exposure_known then 
  if YCGM then
write('L=(',Y2Y:5:3,'*',Ym:4:2,'*Y+',C2C:5:3,'*',Cm:4:2,'*C+',
            Gy2Gy:5:3,'*',GYm:4:2,'*G+',M2M:5:3,'*',Mm:4:2,'*M)*',
       SRx(2,1/(exposure*toCdM2)))
  else
write('L=(',R2R:5:3,'*',Rm:4:2,'*R+',G2G:5:3,'*',Gm:4:2,'*G+',B2B:5:3,'*',Bm:4:2,'*B)*',
       SRx(2,1/(exposure*toCdM2)));
writeln;

if nondark then
 begin
if YCGM then
write(
'# %    Y     C     G     M readings')
else
write(
'# %    R     G1    G2    B readings');

if exposure_known then 

if YCGM then
write(                              '  Y        C        G        M        L / cd/m2')
else
write(                              '  R        G        B        L / cd/m2');
 end
else 
 begin
if YCGM then
write(
'# %      Y       sum    C      sum    G      sum    M      sum')
else
write(
'# %      R       sum    G1     sum    G2     sum    B      sum');
 end;

writeln; 
i:=1;
for k:=1 to 118 do
 begin
  if k<100 then 
   write(k:3,'   ') 
  else if k<109 then
   begin write(99+0.1*(k-99):5:1,' '); i:=10; end
  else if k<118 then
   begin write(99.9+0.01*(k-108):6:2); i:=100; end
  else 
   write('100   ');
  for j:=1 to 4 do
   begin
    write(percvalall[cam[j]][k] - dark :6);
    if not nondark then 
     begin
      inc(percvalsum[j],(percvalall[cam[j]][k]-dark) div i);
      write(percvalsum[j] :8);
     end; 
   end;
  if exposure_known and nondark then
if YCGM then
    begin
    Y:= Y2Y* (percvalall[cam[1]][k] - darkFloat)  /exposure ;
    C:= C2C* (percvalall[cam[2]][k] - darkFloat)  /exposure ;
    GY:=Gy2Gy* (percvalall[cam[3]][k] - darkFloat) /exposure  ;
    M:= M2M* (percvalall[cam[4]][k] - darkFloat) /exposure  ;
    L:= Ym*Y + Cm*C + GYm*GY + Mm*M ;
    write('      ',
          SRxb(2,Y/toCdM2,7), '  ' ,
          SRxb(2,C/toCdM2,7), '  ' ,
	  SRxb(2,GY/toCdM2,7), '  ' ,
	  SRxb(2,M/toCdM2,7), '  ' ,
	  SRxb(2,L/toCdM2,7) );
   end	      
else
   begin
    R:=R2R*(percvalall[cam[1]][k] - darkFloat)  /exposure ;
    G:=G2G*0.5  *(percvalall[cam[2]][k]+percvalall[cam[3]][k] - 2*darkFloat)/exposure ;
    B:=B2B*(percvalall[cam[4]][k] - darkFloat) /exposure  ;
    L:=Rm*R + Gm*G + Bm*B;
    write('        ',
          SRxb(2,R/toCdM2,7), '  ' ,
          SRxb(2,G/toCdM2,7), '  ' ,
	  SRxb(2,B/toCdM2,7), '  ' ,
	  SRxb(2,L/toCdM2,7) );
   end;	  
  writeln; 
 end;
end;
 
writeln; 
write('# Selected image percentils         ');
if exposure_known then 
if YCGM then
write('L=(',Y2Y:5:3,'*',Ym:4:2,'*Y+',C2C:5:3,'*',Cm:4:2,'*C+',
            Gy2Gy:5:3,'*',GYm:4:2,'*G+',M2M:5:3,'*',Mm:4:2,'*M)*',
       SRx(2,1/(exposure*toCdM2)))
else
write('L=(',R2R:5:3,'*',Rm:4:2,'*R+',G2G:5:3,'*',Gm:4:2,'*G+',B2B:5:3,'*',Bm:4:2,'*B)*',
       SRx(2,1/(exposure*toCdM2)));
writeln;
if YCGM then
write(
'# %    Y     C     G     M readings')
else
write(
'# %    R     G1    G2    B readings');

if exposure_known then 

if YCGM then
write(                              '  Y        C        G        M        L / cd/m2')
else
write(                              '  R        G        B        L / cd/m2');

writeln; 
for k:=1 to percn do
 begin
  write(percv[k]:3);
  for j:=1 to 4 do
   begin
    write(percval[cam[j]][k] - dark :6);
   end;
  if exposure_known then
if YCGM then
    begin
    Y:= Y2Y* (percval[cam[1]][k] - darkFloat)  /exposure ;
    C:= C2C* (percval[cam[2]][k] - darkFloat)  /exposure ;
    GY:=Gy2Gy* (percval[cam[3]][k] - darkFloat) /exposure  ;
    M:= M2M* (percval[cam[4]][k] - darkFloat) /exposure  ;
    L:= Ym*Y + Cm*C + GYm*GY + Mm*M ;
    write('      ',
          SRxb(2,Y/toCdM2,7), '  ' ,
          SRxb(2,C/toCdM2,7), '  ' ,
	  SRxb(2,GY/toCdM2,7), '  ' ,
	  SRxb(2,M/toCdM2,7), '  ' ,
	  SRxb(2,L/toCdM2,7) );
   end	      
else
   begin
    R:=R2R*(percval[cam[1]][k] - darkFloat)  /exposure ;
    G:=G2G*0.5  *(percval[cam[2]][k]+percval[cam[3]][k] - 2*darkFloat)/exposure ;
    B:=B2B*(percval[cam[4]][k] - darkFloat) /exposure  ;
    L:=Rm*R + Gm*G + Bm*B;
    write('        ',
          SRxb(2,R/toCdM2,7), '  ' ,
          SRxb(2,G/toCdM2,7), '  ' ,
	  SRxb(2,B/toCdM2,7), '  ' ,
	  SRxb(2,L/toCdM2,7) );
   end;	  
  writeln; 
 end;

SpaceAngle:=SpaceAngle*FourPixSA;

  if exposure_known then
if NonCalibrated then
   begin
    if PixAngSizeKnown then
     write('# (some illum) from',SpaceAngle:5:2,' sr')
    else
     write('# (some illum) from ??? sr');
    writeln(
	  SRxb(1,FourPixSA*Lsum,7) );
    if NonLinear then 
     writeln('# and average luminance is', SRx(3,FourPixSA*Lsum/SpaceAngle)); 	  
   end	      
else
   begin 
    if PixAngSizeKnown then
     begin
      if SumGlare then
       write('# veiling luminance ',SRxb(1,18*VeiLum*FourPixSA,6),' cd/m2,')
      else write('#');
      write(' flux from',SRx(2,SpaceAngle));
      if ((sumN[cam[2]]+sumN[cam[3]])>1.01*(sumNRaw[cam[2]]+sumNRaw[cam[3]])) 
      and (minL=minLC) then 
       write('*',
(sumNRaw[cam[2]]+sumNRaw[cam[3]])/(sumN[cam[2]]+sumN[cam[3]]):4:2);
      write(' sr (',SRx(2,FourPixSA),' sr/4px) is ')
     end
    else
     write('# flux from ??? sr');

    write(SRx(2,FourPixSA*iLsum),' lx');
    if fuji then 
     write(' (',SRx(2,iLsumT),' lx tilewise)');
    if SpaceAngle>3 then 	  
    write(' (SQM',
	  SRx(2,FourPixSA*iLSQMsum/1.53), ' nt,',
  	   -2.5*ln( (FourPixSA*iLSQMsum/1.53) *
                          sqr(Pi/180/3600) / ZeroMag ) / ln10
           :6:2 , ' mag)'
	   );
    if NonLinear then 
     writeln('# and average luminance is', SRx(3,FourPixSA*Lsum/SpaceAngle))
    else  	  
     write(';'+cl+'# tilewise (',
      SRx(2,SideX*rad_to_deg(FourPixXS)),'x',
      SRx(2,SideY*rad_to_deg(FourPixYS)),'',
      ') luminance ',SRx(2,LsumT/Tcount),' cd/m2 with rel. SD', 
      SRx(2,100 * sqrt((LsumQ - sqr(LsumT)/Tcount)
                    / (Tcount-1)) 
		  / (LsumT/Tcount)),' %');
    if maxL=maxLC then	
     if minL=minLC then 
      write(' (summing pixels below ',ovlim:5)
     else  
      write(' (points with luminances over ',SRxb(1,minL,7))
    else
     if minL=minLC then
      write(' (points with luminances below ',SRxb(1,maxL,7))
     else
      write(' (points with luminances over ',SRxb(1,minL,7),
                                 ' and below ',SRxb(1,maxL,7));
    if (sumN[cam[2]]+sumN[cam[3]]<1.01*(sumNRaw[cam[2]]+sumNRaw[cam[3]]))
    or (minL>minLC) then 
     writeln(')') 
    else 
     writeln(' and with non-zero green: there is',
      100.0*(sumNRaw[cam[2]]+sumNRaw[cam[3]])/(sumN[cam[2]]+sumN[cam[3]])
      :5:1,' % of them)')
   end
 else  
   writeln; 

if Fuji and FlatFielding then
 write('# Fuji Devignetting: ',FujiDevi,' ');
  
if DarkStrip then
 if SubDF then
   if SubOffset and not (ScaleDark=1) then 
    writeln('# dark frame ', DarkFrame, ' scaled by ', 
     SRx(3,ScaleDark), '(after subtracting an offset frame ', OffsetFrame, 
          ' from both images) subtracted; DarkStrip av.=',
	  darkFloat-dark : 5:1,'  min.=', darkmin-dark :5, 
	  '  max.=',darkmax-dark : 5)
   else	  
    writeln('# DarkStrip av.=',darkFloat-dark : 5:1,
        '  min.=', darkmin-dark :5, '  max.=',darkmax-dark : 5,
        ' (dark frame ', DarkFrame, ' subtracted from all values)')
 else
  writeln('# dark average=',darkFloat : 5:1,
        '  minimum=', darkmin-dark :5, '  maximum=',darkmax-dark : 5,
        ' (dark is subtracted from the other data)')
else
 if SubDF then
  if SubOffset and not (ScaleDark=1) then 
    writeln('# dark frame ', DarkFrame, ' scaled by ', 
     SRx(3,ScaleDark), ' (after subtracting an offset frame ', OffsetFrame, 
          ' from both images) subtracted')
  else	  
    writeln('# dark frame ', DarkFrame, ' subtracted from all values')
 else
  writeln('# dark=',dark, ' has been substracted from all values'); 
	                
for j:=1 to 4 do 
 begin
  if YCGM then
   write('# ',colorY[j])
  else 
   write('# ',color[j]);
  if nondark then
   write(              ' average=',(sumt[cam[j]] - sumN[cam[j]] * dark)
                                      / sumNRaw[cam[j]] : 6:1)
  else
   write(              ' average=',sumt[cam[j]] / sumN[cam[j]] - dark: 6:1);
  write(
        '  minimum=', mint[cam[j]] - dark:5, '  maximum=',maxt[cam[j]] - dark : 5);
  if (maxL=maxLC) and (minL=minLC) then 
   write(	
	'   over ',ovlim :4,': ', osumt[j]:3)
  else	
   write(	
	'   out of range: ', osumt[j]:3); 
  if (sumN[cam[j]] > 1.01*(sumNRaw[cam[j]])) then 
   if nondark then
    writeln(' zero:',100 * (1.0 - sumNRaw[cam[j]]/sumN[cam[j]]):5:1,' %')
   else
    writeln('( zero:',100 * (1.0 - sumNRaw[cam[j]]/sumN[cam[j]]):5:1,' %)')
  else writeln;                  
 end;

writeln(cl,
 'End of results of "raw2lum" (version ', version,') with parameters:',cl,
 ' ',CommandLine);

if AppResults then
 begin 
  assign(f1t,'overview_r2l.txt');
 {$I-}
   append(f1t);
   if ioresult<>0 then
   rewrite(f1t);
 {$I+}
  
  if OverwHead then 
   begin
    write(f1t,
'No  ');
    if length(ImName)>2 then 
     for j:=3 to length(ImName) do write(f1t,' ');
    if YCGM then
     writeln(f1t,
    'Expos.  f/ ISO foc.  val2lumi.  Y     C      G      M     taken at UTC+1h')
    else
     writeln(f1t, 
    'Expos.  f/ ISO foc.  val2lumi.  R     G1     G2     B     taken at UTC+1h');
    if length(ImName)>2 then 
     for j:=3 to length(ImName) do write(f1t,' ');
    writeln(f1t, 
'    durat.        length  coeff.    pixel values averages     time      date');    
   end;
  write(f1t,ImName,exp_length:7:3,foc_ratio:5:1,ISO:4,TrueFocalLength:6:1,
        SRxb(1,tolum,8));
  for j:=1 to 4 do 
  if nondark then 
   write(f1t,(sumt[cam[j]] - (sumN[cam[j]] * dark))
                                      / sumNRaw[cam[j]]: 7:1)
  else
   write(f1t, sumt[cam[j]] / sumN[cam[j]] - dark: 7:1);
  write(f1t,' ',ImTime,' ',ImDate,cl); 
  close(f1t)
 end;
  
end.      
